#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxe = 700000;
const int maxn = 205;
const ll inf = 1e18;

struct flow
{
	ll f[maxe], c[maxe], lvl[maxn];
	vector < pair < int, int > > g[maxn];
	int pr[maxn];

	int n, eCnt;
	int s, t;

	int cut[maxn];

	flow(int _n)
	{
		n = _n;
		eCnt = 0;
	}

	void addEdge(int v, int u, ll cap)
	{
		f[eCnt] = f[eCnt + 1] = 0;
		c[eCnt] = cap;
		c[eCnt  + 1] = 0;
		assert(cap >= 0);
		g[v].pb(mp(u, eCnt));
		g[u].pb(mp(v, eCnt + 1));
		eCnt += 2;
	}

	bool bfs()
	{
		for (int i = 0; i < n; i++)
			lvl[i] = -1;
		lvl[s] = 0;

		queue < int > q;
		q.push(s);

		while (!q.empty())
		{
			int v = q.front();
			q.pop();

			for (pair < int, int > to : g[v])
			{
				if (lvl[to.fst] != -1)
					continue;

				if (f[to.snd] == c[to.snd])
					continue;

				lvl[to.fst] = lvl[v] + 1;
				q.push(to.fst);
			}
		}

		return lvl[t] != -1;
	}

	ll dfs(int v, ll flow)
	{
		if (v == t || flow == 0)
		{
			return flow;
		}
		for (; pr[v] < g[v].size(); pr[v]++)
		{
			auto to = g[v][pr[v]];
			if (lvl[v] + 1 != lvl[to.fst])
				continue;

			if (f[to.snd] == c[to.snd])
				continue;

			if (ll res = dfs(to.fst, min(flow, c[to.snd] - f[to.snd])))
			{
				f[to.snd] += res;
				f[to.snd ^ 1] -= res;
				return res;
			}
		}
		return 0;
	}

	void calc()
	{
		while (bfs())
		{
			for (int i = 0; i < n; i++)
				pr[i] = 0;
			while (dfs(s, inf))
			{
			}
		}

		for (int i = 0; i < n; i++)
			cut[i] = 0;

		queue < int > q;
		q.push(s);
		cut[s] = 1;

		while (!q.empty())
		{
			int v = q.front();
			q.pop();

			for (pair < int, int > to : g[v])
			{
				if (f[to.snd] == c[to.snd])
					continue;

				if (cut[to.fst])
					continue;

				cut[to.fst] = 1;
				q.push(to.fst);
			}
		}
	}
};

vector < pair < int, int > > edges;
int deg[maxn];
vector < int > ans;

bool check(ll num, ll den, int n)
{
	flow *f = new flow(n + 2);

	for (int i = 0; i < n; i++)
		deg[i] = 0;

	for (pair < int, int >  e : edges)
	{
		f->addEdge(e.fst, e.snd, den);
		f->addEdge(e.snd, e.fst, den);
		deg[e.fst]++;
		deg[e.snd]++;
	}

	f->s = n;
	f->t = n + 1;

	ll m = edges.size();

	for (int i = 0; i < n; i++)
		f->addEdge(f->s, i, m * den);

	for (int i = 0; i < n; i++)
	{
		f->addEdge(i, f->t, m * den + 2LL * num - den * ((ll)deg[i]));
	}

	f->calc();

	int cnt = 0;
	vector < int > a;
	for (int i = 0; i < n; i++)
	{
		cnt += f->cut[i];
		if (f->cut[i])
			a.pb(i);
	}

	if (a.size() != 0)
		ans = a;

	delete f;

	return cnt;
}

int a[maxn];

bool comp(pair < ll, ll > &p1, pair < ll, ll > &p2)
{
	return p1.fst * p2.snd < p1.snd * p2.fst;
}

int main()
{
//	freopen("a.in", "r", stdin);
	int t;
	cin >> t;
	//t = 1;
	int gg = 0;



	vector < pair < ll, ll > > v;
	for (int i = 0; i < 20005; i++)
	{
		for (int j = 1; j < 105; j++)
		{
			v.pb(mp(i, j));
		}
	}

	sort(v.begin(), v.end(), comp);



	while (t--)
	{
		int n;
		cin >> n;
		for (int i = 0; i < n; i++)
			cin >> a[i];
		//n = 100;

		edges.clear();

		for (int i = 0; i < n; i++)
			for (int j = i + 1; j < n; j++)
				if (a[i] > a[j])
					edges.pb(mp(i, j));

		//ld lo = 0, hi = 205;

		/*for (int iter = 0; iter < 40; iter++)
		{
			ld mid = (lo + hi) / 2;
			
			if (check(mid * 1e5, 1e5, n))
				lo = mid;
			else
				hi = mid;
		}*/

		int lo = -1, hi = v.size();
		while (hi - lo > 1)
		{
			int mid = (lo + hi) >> 1;

			if (check(v[mid].fst, v[mid].snd, n))
				lo = mid;
			else
				hi = mid;
		}


		ld x = 0;

		for (int i = 0; i < ans.size(); i++)
		{
			for (int j = 0; j < ans.size(); j++)
			{
				if (ans[i] < ans[j] && a[ans[i]] > a[ans[j]])
					x += 1;
			}
		}

		x /= ans.size();

		if (ans.size() == 0)
			x = 0;

		gg++;
		cout.precision(10);
		//cout << ans.size() << endl;
		cout << "Case #" << gg << ": ";
		cout << fixed << x << endl;
		
	}
	return 0;
}