#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;


int calcinvs(const vector<int>& a) {
	int n = sz(a);
	int ans = 0;
	forn(i, n) forn(j, i) ans += a[i] < a[j];
	return ans;
}

double solvestupid(const vector<int>& a) {
	int n = sz(a);
	pair<double, vector<int> > best = mp(-1, vector<int>());
	forn(iter, (1<<n)) {
		vector<int> cur;
		forn(i, n) if (iter&(1<<i)) cur.pb(a[i]);
		int invcnt = calcinvs(cur);
		best = max(best, mp(invcnt/(double)sz(cur), cur));
	}
	return best.X;
}


double ANS;

vector<int> onestep(const vector<int>& a) {
	int invs = 0;
	int n = sz(a);
	forn(i, n) forn(j, i) if (a[i] < a[j]) invs++;
	double curans = (double)invs/sz(a);
	ANS = curans;
	if (sz(a) == 1) return a;
	double bestans = -1;
	int bp = -1;
	forn(i, n) {
		int cc = 0;
		forn(j, n) {
			if (j < i && a[j] > a[i]) ++cc;
			if (j > i && a[i] > a[j]) ++cc;
		}
		double tans = (double)(invs - cc)/(n-1);
		if (tans > bestans) {
			bestans = tans;
			bp = i;
		}
	}
	if (bestans <= curans) return a;
	vector<int> res = a;
	res.erase(res.begin()+bp);
	return res;
}

double solves(vector<int> a) {
	while (true) {
		vector<int> res = onestep(a);
		if (sz(res) == sz(a)) break;
		a = res;
	}
	return ANS;
}
double solvesmart(vector<int> a) {
	if (sz(a) == 1) return 0;
	if (sz(a) < 25) return solvestupid(a);
	double res = solves(a);
	int n = sz(a);
	forn(i, n) {
		vector<int> b = a;
		b.erase(b.begin()+i);
		double curans = solves(b);
		res = max(curans, res);
	}

	forn(iter, 50) {
		vector<int> v;
		forn(i, n) if (rand()%100 < 67) v.pb(a[i]);
		if (sz(v) < 2) continue;
		double curans = solves(v);
		res = max(curans, res);
	}


	/*if (sz(a) > 2) 
	forn(i, n) forn(j, i) {
		if (rand()%10 < 9) continue;
		vector<int> c = a;
		c.erase(c.begin()+i);
		c.erase(c.begin()+j);
		double curans = solves(c);
		res = max(curans, res);
	}*/
	return res;
}



void solve() {
	int n; scanf("%d", &n);
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]);
	double res = solvesmart(a);
	printf("%.15lf\n", res);
}

void stress() {
	forn(iter, 10000) {
		cerr << iter << "\n";
		int n = 2;
		vector<int> a(n);
		forn(i, n) a[i] = i;
		random_shuffle(ALL(a));
		double ans1 = solvestupid(a);
		double ans2 = solvesmart(a);
		if (ans1 != ans2) {
			cerr << ans1 << " " << ans2 << "\n";
			printf("FAIL!\n");
			exit(0);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	//stress();
	//return 0;
	int T; scanf("%d", &T); for (int t = 1; t <= T; ++t) {
		printf("Case #%d: ", t);
		solve();
	}
	return 0;
}
