#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int mod = 1000000007;

struct num {
	int x;
	num():x(0) {}
	num(int x):x(x) {}
	num operator+(const num& o) const {
		num res(x+o.x);
		if (res.x >= mod) res.x -= mod;
		return res;
	}
	num operator-(const num& o) const {
		num res(x-o.x);
		if (res.x < 0) res.x += mod;
		return res;
	}
	num operator*(const num& o) const {
		return num(x*(ll)o.x%mod);
	}
	num pow(int n) const {
		num res(1);
		num t = *this;
		while (n) {
			if (n&1) res = res * t;
			t = t * t;
			n >>= 1;
		}
		return res;
	}
};

const int maxn = 1000010;
num fact[maxn];
num revfact[maxn];


num comb(int n, int k) {
	if (k > n) return num(0);
	return fact[n] * revfact[k] * revfact[n-k];
}

void solve() {
	int n, m, k; scanf("%d%d%d", &n, &m, &k);
	num ans(0);
	num mult(1);
	for (int c = 0; c <= k; ++c) {
		int p = k-c;
		if (p > m) continue;
		num curadd = comb(k, c) * p * (num(p)-num(1)).pow(n-1);
		ans = ans + curadd * mult;
		mult = num(0)-mult;
	}
	ans = ans * comb(m, k);
	printf("%d\n", ans.x);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	fact[0] = num(1);
	for (int i = 1; i < maxn; ++i) fact[i] = fact[i-1] * num(i);
	forn(i, maxn) revfact[i] = fact[i].pow(mod-2);
	int T; scanf("%d", &T); for (int t = 1; t <= T; ++t) {
		printf("Case #%d: ", t);
		solve();
	}
	return 0;
}
