#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 422224

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

struct node
{
	int len, link, num;
	int next[26];
	node() { memset(next,-1,sizeof(next)); }
	node(int tlen, int tlink, int tnum) : len(tlen), link(tlink), num(tnum) { memset(next, -1,sizeof(next)); }
	void init(int tlen, int tlink) { len = tlen; link = tlink; memset(next, -1,sizeof(next)); }
};

char s[MAXN];
string t;
node a[MAXN];
node a2[MAXN];
int last;
int n;

inline void init()
{
	a[0] = node(-1, 0, 0);
	a[1] = node(0, 0, 0);
	n = 2;
	last = 0;
}

inline void init2()
{
	a2[0] = node(-1, 0, 0);
	a2[1] = node(0, 0, 0);
	n = 2;
	last = 0;
}

inline bool add(int pos)
{
	int cur = s[pos] - 'a';
	while(s[pos] != s[pos - 1 - a[last].len])
		last = a[last].link;
	if (a[last].next[cur] != -1)
	{
		last = a[last].next[cur];
		++a[last].num;
		return 0;
	}
	int link = a[last].link;
	while(s[pos] != s[pos - 1 - a[link].len])
		link = a[link].link;
	a[n] = node(a[last].len + 2, a[link].next[cur] < 1 ? 1 : a[link].next[cur], 1);
	a[last].next[cur] = n;
	last = n++;
	return 1;
}

inline bool add2(int pos)
{
	int cur = s[pos] - 'a';
	while(s[pos] != s[pos - 1 - a2[last].len])
		last = a2[last].link;
	if (a2[last].next[cur] != -1)
	{
		last = a2[last].next[cur];
		++a2[last].num;
		return 0;
	}
	int link = a2[last].link;
	while(s[pos] != s[pos - 1 - a2[link].len])
		link = a2[link].link;
	a2[n] = node(a2[last].len + 2, a2[link].next[cur] < 1 ? 1 : a2[link].next[cur], 1);
	a2[last].next[cur] = n;
	last = n++;
	return 1;
}

inline ll go(int v1, int v2)
{
	ll res = 0;
	if (v1 > 1 && v2 > 1)
		res += 1LL * a[v1].num * a2[v2].num;
	for (int i = 0; i < 26; ++i)
		if (a[v1].next[i] != -1 && a2[v2].next[i] != -1)
			res += go(a[v1].next[i],a2[v2].next[i]);
	return res;
}

inline void solve()
{
 	init();
	scanf("%s", s + 1);
	int l = strlen(s + 1);
	for (int i = 1; i <= l; ++i)
		add(i);
	for (int i = n - 1; i >= 1; --i)
		a[a[i].link].num += a[i].num;
	init2();
	scanf("%s", s + 1);
	l = strlen(s + 1);
	for (int i = 1; i <= l; ++i)
		add2(i);
	for (int i = n - 1; i >= 1; --i)
		a2[a2[i].link].num += a2[i].num;
	cout << go(0, 0) + go(1, 1) << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int tt;
	scanf("%d", &tt);
	for (int t = 0; t < tt; ++t)
	{
		printf("Case #%d: ", t + 1);
		solve();
	}
	return 0;
}
