#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "c"

struct Edge
{
	int to, c, f;
	
	Edge() {}
	
	Edge(int to): to(to), c(0), f(0) {}
	
};

Edge edge[1000001];
int ec = 0;
vector <int> g[1001];
int N, S, T;

void add_edge(int u, int v)
{
	g[u].pb(ec);
	edge[ec++] = Edge(v);
	g[v].pb(ec);
	edge[ec++] = Edge(u);
}

int a[1001];
pair <int, int> fr[1000001];
int fr_cnt = 0;
vector <int> p_id;
vector <int> q_id;

void init(int p, int q)
{
	for (int i = 0; i < ec; ++i)
		edge[i].f = 0;
	for (int i = 0; i < sz(p_id); ++i)
		edge[p_id[i]].c = 2 * p;
	for (int i = 0; i < sz(q_id); ++i)
		edge[q_id[i]].c = q;
}

bool used[1001];
int level[1001];
int ptr[1001];
queue <int> q;

bool bfs()
{
	memset(used, 0, sizeof(bool) * N);
	while (!q.empty())
		q.pop();
	q.push(S);
	used[S] = true;
	while (!q.empty())
	{
		int u = q.front();
		q.pop();
		for (int i = 0; i < sz(g[u]); ++i)
		{
			int ed = g[u][i];
			if (edge[ed].c == edge[ed].f)
				continue;
			int v = edge[ed].to;
			if (used[v])
				continue;
			used[v] = true;
			level[v] = level[u] + 1;
			q.push(v);
		}
	}
	return used[T];
}

int dfs(int u = S, int x = 1e9)
{
	if (u == T)
		return x;
	int res = 0;
	for (int &i = ptr[u]; i < sz(g[u]); ++i)
	{
		int ed = g[u][i];
		if (edge[ed].f == edge[ed].c)
			continue;
		int v = edge[ed].to;
		if (level[v] != level[u] + 1)
			continue;
		int delta = min(x, edge[ed].c - edge[ed].f);
		delta = dfs(v, delta);
		res += delta;
		x -= delta;
		edge[ed].f += delta;
		edge[ed ^ 1].f -= delta;
	}
	return res;
}

bool check(int p, int q, ll E)
{
//	cerr << p << ' ' << q << '\n';
	init(p, q);
	ll flow = 0;
	while (bfs())
	{
		memset(ptr, 0, sizeof(int) * N);
		flow += dfs();
	}
	bool fail = true;
	for (int i = 0; i < N - 2; ++i)
		if (!used[i])
			fail = false;
	if (fail)
		return false;
	assert(flow % 2 == 0);
	flow /= 2;
//	cerr << E * q - flow << '\n';
	return E * q >= flow;
}

int test_id = 1;

void solve()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i);
	ec = 0;
	N = n + 2;
	S = n, T = n + 1;
	for (int i = 0; i < N; ++i)
		g[i].clear();
	p_id.clear();
	q_id.clear();
	
	for (int i = 0; i < n; ++i)
	{
		p_id.pb(ec);
		add_edge(S, i);
	}
	int E = 0;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			if (a[i] > a[j])
			{
				++E;
				q_id.pb(ec);
				add_edge(i, T);
				q_id.pb(ec);
				add_edge(j, T);
				q_id.pb(ec);
				q_id.pb(ec + 1);
				add_edge(i, j);
			}
	
	int lb = 0, rb = fr_cnt;
	while (lb + 1 < rb)
	{
		int c = (lb + rb) / 2;
		int p = fr[c].fi;
		int q = fr[c].se;
//		cerr << check(p, q, E) << '\n';
		if (check(p, q, E))
			lb = c;
		else
			rb = c;
	}
//	cerr << fr[lb].fi << ' ' << fr[lb].se << '\n';
	cout << "Case #" << test_id++ << ": " << double(fr[lb].fi) / double(fr[lb].se) << '\n';
}

bool frac_cmp(const pair <int, int> &a, const pair <int, int> &b)
{
	return a.fi * b.se < a.se * b.fi;
}

int main()
{
	cout.precision(10);
	cout.setf(ios::fixed);
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	for (int i = 0; i <= 5000; ++i)
		for (int j = 1; j <= 100; ++j)
			if (__gcd(i, j) == 1)
				fr[fr_cnt++] = mp(i, j);
	sort(fr, fr + fr_cnt, frac_cmp);
	int tn;
	cin >> tn;
	for (int i = 0; i < tn; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
