#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "c"

int f[104][104];
int c[104][104];
int N, S, T;

int a[104];
pair <int, int> fr[1000001];
int fr_cnt = 0;

void gen(int a, int b, int c, int d)
{
	int x = a + c, y = b + d;
	if (y > N - 2) return;
	gen(a, b, x, y);
	fr[fr_cnt++] = mp(x, y);
	gen(x, y, c, d);
}

int init(int p, int q)
{
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			c[i][j] = f[i][j] = 0;
	for (int i = 0; i < N - 2; ++i)
		c[S][i] = 2 * p;
	int E = 0;
	for (int i = 0; i < N - 2; ++i)
		for (int j = i + 1; j < N - 2; ++j)
			if (a[i] > a[j])
			{
				++E;
				c[i][T] += q;
				c[j][T] += q;
				c[i][j] = c[j][i] = q;
			}
	return E;
}

bool used[1001];
int level[1001];
int ptr[1001];
queue <int> q;

bool bfs()
{
	fill(used, used + N, false);
	while (!q.empty())
		q.pop();
	q.push(S);
	used[S] = true;
	while (!q.empty())
	{
		int u = q.front();
		q.pop();
		for (int v = 0; v < N; ++v)
		{
			if (c[u][v] == f[u][v])
				continue;
			if (used[v])
				continue;
			used[v] = true;
			level[v] = level[u] + 1;
			q.push(v);
		}
	}
	return used[T];
}

int dfs(int u = S, int x = 1e9)
{
	if (u == T)
		return x;
	int res = 0;
	for (int &v = ptr[u]; v < N; ++v)
	{
		int delta = min(x, c[u][v] - f[u][v]);
		if (delta == 0)
			continue;
		if (level[v] != level[u] + 1)
			continue;
		delta = dfs(v, delta);
		res += delta;
		x -= delta;
		f[u][v] += delta;
		f[v][u] -= delta;
	}
	return res;
}

bool check(int p, int q)
{
//	cerr << p << ' ' << q << '\n';
	ll E = init(p, q);
	ll flow = 0;
	while (bfs())
	{
		memset(ptr, 0, sizeof(int) * N);
		flow += dfs();
	}
	bool fail = true;
	for (int i = 0; i < N - 2; ++i)
		if (!used[i])
			fail = false;
	if (fail)
		return false;
	assert(flow % 2 == 0);
	flow /= 2;
	return E * q >= flow;
}

int test_id = 1;

void solve()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i);
	N = n + 2;
	S = n, T = n + 1;
	
	fr_cnt = 0;
	fr[fr_cnt++] = mp(0, 1);
	gen(0, 1, 1, 1);
	int lb = 0, rb = fr_cnt * ((n + 1) / 2);
	while (lb + 1 < rb)
	{
		int c = (lb + rb) / 2;
		int add = c / fr_cnt;
		int p = fr[c % fr_cnt].fi;
		int q = fr[c % fr_cnt].se;
		p += add * q;
		if (check(p, q))
			lb = c;
		else
			rb = c;
	}
	int add = lb / fr_cnt;
	int p = fr[lb % fr_cnt].fi;
	int q = fr[lb % fr_cnt].se;
	p += add * q;
	cout << "Case #" << test_id++ << ": " << double(p) / double(q) << '\n';
}

bool frac_cmp(const pair <int, int> &a, const pair <int, int> &b)
{
	return a.fi * b.se < a.se * b.fi;
}

int main()
{
	cout.precision(10);
	cout.setf(ios::fixed);
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int tn;
	cin >> tn;
	for (int i = 0; i < tn; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
