#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "i"

typedef unsigned int uint;

const int maxn = 30000;
const int maxlen = 32;

struct node
{
	int to[2];
	int mark;
	
	node(): mark(0)
	{
		to[0] = to[1] = -1;
	}
};

node trie[maxn * maxlen + 1];
int tsz = 0;

void add(uint msk, int pref)
{
	int v = 0;
	for (int i = 0; i < pref; ++i)
	{
		int c = (msk >> (31 - i)) & 1;
		if (trie[v].to[c] == -1)
		{
			trie[v].to[c] = tsz;
			trie[tsz++] = node();
		}
		v = trie[v].to[c];
	}
	trie[v].mark = 1;
}

void init()
{
	tsz = 0;
	trie[tsz++] = node();
}

int n;
vector< pair<uint, int> > ans;

void go(int v, uint msk, int d)
{
	if (trie[v].mark) return;
	if (trie[v].to[0] == -1)
		ans.pb(mp(msk, d + 1));
	else
		go(trie[v].to[0], msk, d + 1);
	
	if (trie[v].to[1] == -1)
		ans.pb(mp(msk | (1u << (31 - d)), d + 1));
	else
		go(trie[v].to[1], msk | (1u << (31 - d)), d + 1);
}

void readIp(uint &msk, int &pref)
{
	char ip[100];
	scanf("%s\n", ip);
	int ptr = 0;
	msk = 0;
	for (int i = 0; i < 4; ++i)
	{
		int x = 0;
		while (isdigit(ip[ptr]))
			x = x * 10 + ip[ptr] - '0', ptr++;
		for (int j = 0; j < 8; ++j)
			msk |= ((x >> j) & 1) << (24 - 8 * i + j);
		ptr++;
	}
	sscanf(ip + ptr, "%d", &pref);
}

void printIp(uint msk, int pref)
{
	for (int i = 0; i < 4; ++i)
	{
		int x = (msk >> (24 - 8 * i)) & 255;
		printf("%d%c", x, (i == 3 ? '/' : '.'));
	}
	printf("%d\n", pref);
}

void solve(int t)
{
	scanf("%d\n", &n);
	init();
	for (int i = 0; i < n; ++i)
	{
		uint msk;
		int pref;
		readIp(msk, pref);
		add(msk, pref);
	}
	if (n == 0)
	{
		printf("Case #%d:\n", t);
		printf("1\n0.0.0.0/0\n");
		return;
	}
	for (int v = tsz - 1; v >= 0; --v)
	{
		int l = trie[v].to[0], r = trie[v].to[1];
		if (l != -1 && r != -1 && trie[l].mark && trie[r].mark)
			trie[v].mark = 1;
	}
	ans.clear();
	go(0, 0, 0);
	printf("Case #%d:\n", t);
	printf("%d\n", (int) ans.size());
	for (size_t i = 0; i < ans.size(); ++i)
		printIp(ans[i].first, ans[i].second);
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	scanf("%d", &t);
	for (int i = 1; i <= t; ++i)
		solve(i);
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
