import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;


public class Main {
	
	static String toOct(String src) {
		if (src.length() == 8) return src;
		StringBuilder sb = new StringBuilder();
		for (int i=0; i<(8-src.length());++i) {
			sb.append('0');
		}
		sb.append(src);
		return sb.toString();
	}
	
	static void outPrefix(String prefix) {
		int mask = prefix.length();
		StringBuilder b = new StringBuilder(prefix);
		for (int i=prefix.length();i<32;++i) {
			b.append('0');
		}
		int a1 = Integer.parseInt(b.substring(0, 8), 2);
		int a2 = Integer.parseInt(b.substring(8, 16), 2);
		int a3 = Integer.parseInt(b.substring(16, 24), 2);
		int a4 = Integer.parseInt(b.substring(24, 32), 2);
		System.out.print(a1);
		System.out.print('.');
		System.out.print(a2);
		System.out.print('.');
		System.out.print(a3);
		System.out.print('.');
		System.out.print(a4);
		System.out.print('/');
		System.out.println(mask);
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		HashSet<String>[] prefixes = new HashSet[32];
		HashSet<String>[] addprefixes = new HashSet[32];
		int t = in.nextInt();
		for (int test=0;test<t;++test) {
			System.out.print("Case #");
			System.out.print(test+1);
			System.out.println(':');
			int n = in.nextInt();
			if (n==0) {
				System.out.println(1);
				System.out.println("0.0.0.0/0");
				continue;
			}
			for (int i=0;i<32;++i) {
				prefixes[i] = new HashSet<String>();
				addprefixes[i] = new HashSet<String>();
			}
			for (int i=0;i<n;++i) {
				String[] net = in.next().split("[.|//]");
				String address1 = toOct(Integer.toBinaryString(Integer.parseInt(net[0])));
				String address2 = toOct(Integer.toBinaryString(Integer.parseInt(net[0])));
				String address3 = toOct(Integer.toBinaryString(Integer.parseInt(net[0])));
				String address4 = toOct(Integer.toBinaryString(Integer.parseInt(net[0])));
				String prefix = (address1 + address2 + address3 + address4).
						substring(0, Integer.parseInt(net[4]));
				if (prefix.length() < 32) {
					prefixes[prefix.length()].add(prefix);
				}
			}
			
			boolean empty = true;
			for (int i=1;i<32;++i) {
				if (!prefixes[i].isEmpty()) {
					empty = false;
				}
			}
			if (empty) {
				System.out.println(1);
				System.out.println("0.0.0.0/0");
				continue;
			}
			
			if (!prefixes[0].isEmpty()) {
				System.out.println(0);
				continue;
			}
			
			for (int i=1;i<32;++i) {
				for (String mainprefix : prefixes[i]) {
					for (int j=i+1;j<32;++j) {
						for (String prefix : prefixes[j]) {
							if (prefix.startsWith(mainprefix)) {
								prefixes[j].remove(prefix);
							}
						}
					}
				}
			}
			
			int curlen = 31;
			while (curlen > 0) {
				for (String prefix : prefixes[curlen]) {
					String modified = prefix.substring(0, curlen-1).concat
							(prefix.charAt(curlen-1) == '0' ? "1" : "0");
					if (!prefixes[curlen].contains(modified)) addprefixes[curlen].add(modified);
					prefixes[curlen-1].add(prefix.substring(0, curlen-1));
				}
				--curlen;
			}
			
			int count = 0;
			for (int i=1; i<32; ++i) {
				count += addprefixes[i].size();
			}
			System.out.println(count);
			for (int i=1; i<32; ++i) {
				for (String prefix : addprefixes[i]) {
					outPrefix(prefix);
				}
			}
			
			
			/*if (curlen < 0) {
				System.out.println(1);
				System.out.println("0.0.0.0/0");
				continue;
			}*/
			
			
			
		}
	}

}
