#include <iostream>
#include <iomanip>
#include <vector>

using namespace std;

template <class T>
ostream& operator << (ostream& out, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i)
        out << a[i] << " ";
    return out << endl;
}

void solve(vector <int>& a) {
    vector <int> tmp(a.size());
    tmp[0] = 1;
    int max_ans = 1;
    for (int i = 1; i < (int)a.size(); ++i) {
        tmp[i] = 1;
        for (int j = 0; j < i; ++j) {
            if (a[i] < a[j])
                tmp[i] = max(tmp[i], tmp[j] + 1);
        }
        max_ans = max(max_ans, tmp[i]);
    }
    vector <bool> used(a.size(), false);

    int cur = max_ans;
    for (int j = a.size() - 1; j >= 0; --j)
        if (tmp[j] == cur) {
            used[j] = true;
            --cur;
        }

    int ch, zn;
    zn = max_ans;
    ch = max_ans * (max_ans - 1) / 2;

    if (zn == 1) {
        cout << 0 << endl;
        return;
    }

    while (true) {
        int max_pos = -1;
        int max_cur = 0;
        for (int i = 0; i < (int)a.size(); ++i) {
            int cur = 0;
            if (!used[i]) {
                for (int j = 0; j < i; ++j) {
                    if (a[i] < a[j] && used[j])
                        ++cur;
                }
                for (int j = i + 1; j < (int)a.size(); ++j) {
                    if (a[i] > a[j] && used[j])
                        ++cur;
                }
            }
            if (cur > 0 && (max_pos == -1 || max_cur < cur)) {
                max_pos = i;
                max_cur = cur;
            }
        }
        if (max_pos != - 1 && ch * (zn + 1) <= zn * (ch + max_cur)) {
            used[max_pos] = true;
            ++zn;
            ch += max_cur;
        } else {
            break;
        }
    }
    cout << (double)ch / (double)zn << endl;
}

int main() {
    cout << fixed << setprecision(15);
    ios_base::sync_with_stdio(false);
    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        int n;
        cin >> n;
        vector <int> a(n);
        for (int i = 0; i < n; ++i)
            cin >> a[i];
        cout << "Case #" << test << ": ";
        solve(a);
    }
    return 0;
}
