#include <iostream>
using namespace std;

const int modulo = 1e9 + 7;

int GetBinaryPow(int x, int pw)
{
    if (pw == 0) {
        return 1;
    }

    if ((pw & 1) == 1) {
        return (1LL * x * GetBinaryPow(x, pw - 1)) % modulo;
    }

    return GetBinaryPow((1LL * x * x) % modulo, pw >> 1);
}

const int max_k = 1e6;

int inv[max_k + 1];

int C(int n, int k)
{
    if (n < k) {
        return 0;
    }

    int result = 1;
    for (int i = n; i > n - k; --i) {
        result = (1LL * result * i) % modulo;
    }

    for (int i = 1; i <= k; ++i) {
        result = (1LL * result * inv[i]) % modulo;
    }

    return result;
}

int GetAnswer(int n, int k)
{
    int result = 0;
    int c = 1;
    for (int i = 0; i + 1 < k; ++i) {
        int cur = (1LL * c * (k - i)) % modulo;
        cur = (1LL * cur * GetBinaryPow(k - i - 1, n - 1)) % modulo;

        if ((i & 1) == 1) {
            result -= cur;
            if (result < 0) {
                result += modulo;
            }
        } else {
            result += cur;
            if (result >= modulo) {
                result -= modulo;
            }
        }

        c = (1LL * c * (k - i)) % modulo;
        c = (1LL * c * inv[i + 1]) % modulo;
    }
    return result;
}

int GetAnswer(int n, int m, int k)
{
    return (1LL * C(m, k) * GetAnswer(n, k)) % modulo;
}

int main()
{
    for (int i = 1; i <= max_k; ++i) {
        inv[i] = GetBinaryPow(i, modulo - 2);
    }

    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        int n, m, k;
        cin >> n >> m >> k;

        cout << "Case #" << test << ": ";
        cout << GetAnswer(n, m, k) << endl;
    }


    return 0;
}
