#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring>
#include <unordered_map>
using namespace std;

int const LIM = 2e5 + 10;
long long const P = 37;
const int modulo = 1e9 + 103;

bool is_prime(int x)
{
    for (int i = 2; i * i <= x; ++i) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

long long power[LIM];
vector<long long> ha, hb;
unordered_map<long long, int> ca, cb;

long long get_hash(int from, int to, vector<long long> const &h) {
    long long result = h[to];
    if (from > 0) {
        result -= h[from - 1];
        if (result < 0) {
            result += modulo;
        }
    }
    return (1LL * result * power[LIM - 1 - from]) % modulo;
}

struct node
{
    long long hash;
    int counter;
    int next;

  //  string s;
};

const int max_mem_size = 2e5 + 10;

node mem[max_mem_size];
int mem_size;

unordered_map<long long, int> hash_to_indx;

vector<int> roots;

void mem_clear()
{
    mem_size = 0;
    hash_to_indx.clear();
    roots.clear();
}

//string CUR;

int mem_get_new(long long hash)
{
    mem[mem_size].next = -1;
    mem[mem_size].hash = hash;
    mem[mem_size].counter = 0;
  //  mem[mem_size].s = CUR;
    hash_to_indx[hash] = mem_size;
    ++mem_size;
    return mem_size - 1;
}

bool AddToGraph(long long hash, int& return_indx)
{
    if (hash_to_indx.find(hash) != hash_to_indx.end()) {
        return_indx = hash_to_indx[hash];
        return false;
    } else {
        return_indx = mem_get_new(hash);
        return true;
    }
}

vector<int> top;
vector<int> used;

void top_sort(int v)
{
    used[v] = 1;
    if (mem[v].next != -1 && !used[mem[v].next]) {
        top_sort(mem[v].next);
    }
    top.push_back(v);
}

void top_sort()
{
    used.assign(mem_size, 0);
    top.clear();
    for (int i = 0; i < (int) roots.size(); ++i) {
        if (!used[roots[i]]) {
            top_sort(roots[i]);
        }
    }
}

void calc(unordered_map<long long, int>& mp)
{
    mp.clear();
    top_sort();

    reverse(top.begin(), top.end());

    for (int i = 0; i < (int) top.size(); ++i) {
        int v = top[i];

        mp[mem[v].hash] = mem[v].counter;

        int nx = mem[v].next;
        if (nx != -1) {
            mem[nx].counter += mem[v].counter;
        }
    }
}
/*
void ShowTree(int v, int height)
{
    for (int i = 0; i < height; ++i) {
        cout << " ";
    }
    cout << mem[v].s << " : " << mem[v].counter << " with hash = " << mem[v].hash << endl;

    int nx = mem[v].next;
    if (nx != -1) {
        ShowTree(nx, height + 2);
    }
}
*/

void make_palindroms(char a[LIM], const vector<long long>& h, unordered_map<long long, int>& mp) {
    int n = strlen(a);
    vector<int> t[2];
/*
    cout << a << endl;
    cout << "Palindromes: " << endl;
*/
    t[0].resize(n - 1);
    t[1].resize(n);

    for (int l = -1, r = -1, i = 0; i < n - 1; ++i) {
        t[0][i] = 0;
        if (i < r) {
            t[0][i] = max(t[0][i], min(t[0][r - 1 - i + l], r - i));
        }

        while (i + t[0][i] + 1 < n && i - t[0][i] >= 0 && a[i + t[0][i] + 1] == a[i - t[0][i]]) {
            ++t[0][i];
        }

        if (i + t[0][i] > r) {
            r = i + t[0][i];
            l = i - t[0][i] + 1;
        }
    }
/*
    cout << "  CHETNIE" << endl;
    for (int i = 0; i + 1 < n; ++i) {
        cout << "    " << t[0][i] << endl;
    }
*/
    for (int l = -1, r = -1, i = 0; i < n; ++i) {
        t[1][i] = 1;
        if (i <= r) {
            t[1][i] = max(t[1][i], min(r - i + 1, t[1][l + r - i]));
        }

        while (i + t[1][i] < n && i - t[1][i] >= 0 && a[i + t[1][i]] == a[i - t[1][i]]) {
            ++t[1][i];
        }

        if (t[1][i] + i - 1 > r) {
            r = i + t[1][i] - 1;
            l = i - t[1][i] + 1;
        }
    }

/*
    cout << "  NECHETNIE" << endl;
    for (int i = 0; i < n; ++i) {
        cout << "    " << t[1][i] << endl;
    }
*/

    mem_clear();

    for (int i = 0; i + 1 < n; ++i) {
        if (t[0][i] > 0) {
            int l = i - t[0][i] + 1;
            int r = i + t[0][i];

           // CUR = a.substr(l, r - l + 1);
            int root_indx;
            if (!AddToGraph(get_hash(l, r, h), root_indx)) {
                ++mem[root_indx].counter;
                continue;
            }

            ++mem[root_indx].counter;
            roots.push_back(root_indx);

            ++l;
            --r;

            while (l < r) {
                 //   CUR = a.substr(l, r - l + 1);
                int new_root_indx;
                if (!AddToGraph(get_hash(l, r, h), new_root_indx)) {
                    mem[root_indx].next = new_root_indx;
                    break;
                } else {
                    mem[root_indx].next = new_root_indx;
                }
                root_indx = new_root_indx;
                ++l;
                --r;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (t[1][i] > 0) {
            int l =  i - t[1][i] + 1;
            int r = i + t[1][i] - 1;

//CUR = a.substr(l, r - l + 1);
            int root_indx;
            if (!AddToGraph(get_hash(l, r, h), root_indx)) {
                ++mem[root_indx].counter;
                continue;
            }

            ++mem[root_indx].counter;
            roots.push_back(root_indx);

            ++l;
            --r;

            while (l <= r) {
                //    CUR = a.substr(l, r - l + 1);
                int new_root_indx;
                if (!AddToGraph(get_hash(l, r, h), new_root_indx)) {
                    mem[root_indx].next = new_root_indx;
                    break;
                } else {
                    mem[root_indx].next = new_root_indx;
                }
                root_indx = new_root_indx;
                ++l;
                --r;
            }
        }
    }

    calc(mp);
/*
    cout << a << endl;
    for (int i = 0; i < (int) roots.size(); ++i) {
        ShowTree(roots[i], 2);
    }
*/
}

void make_hash(string const &a, vector<long long> &h) {
    h.resize(a.length());
    h[0] = (a[0] - 'a' + 1);
    for (int i = 1; i < (int) a.length(); ++i) {
        h[i] = (1LL * (a[i] - 'a' + 1) * power[i]) % modulo;
        h[i] += h[i - 1];
        if (h[i] >= modulo) {
            h[i] -= modulo;
        }
    }
}


long long solve(char a[LIM], char b[LIM]) {
    long long answer = 0;

    make_hash(a, ha);
    make_hash(b, hb);

    make_palindroms(a, ha, ca);
    make_palindroms(b, hb, cb);

    for (pair<long long, int> const &pt : ca) {
        if (cb.find(pt.first) != cb.end()) {
            answer += 1LL * pt.second * cb[pt.first];
        }
    }

    return answer;
}

void precalc() {
    power[0] = 1;
    for (int i = 1; i < LIM; ++i) {
        power[i] = (1LL * power[i - 1] * P) % modulo;
    }
}

char a[LIM];
char b[LIM];

int main() {
    /*
    int x = 1e9 + 100;
    while (!is_prime(x)) {
        ++x;
    }
    cout << x << endl;
    return 0;
    */
   // freopen("input.txt", "r", stdin);

    precalc();
    int t;
    scanf("%d\n", &t);
    for (int i = 1; i <= t; ++i) {
        scanf("%s\n%s\n", a, b);
        printf("Case #%d: %lld\n", i, solve(a, b));
    }
    return 0;
}
