#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

typedef vector <vector <char> > vvc;

int timerR = 0;

int dx[4] = {0,0,-1,1};
int dy[4] = {-1,1,0,0};
char gg[4] = {'U','D','L','R'};


struct result {
	int combos;
	int drops;
	vector <int> path;
	int xst;
	int yst;

	result():combos(-1){}

	void print() {
		cout << "Combo:" << combos << " " << "Length:" << path.size() << "\n";
		cout << yst + 1 << " " << xst + 1 << "\n";
		for (int i = 0; i < path.size(); ++i) {
			cout << gg[path[i]];
		}
		cout << "\n";
	}

	void impr(int _combos,
	vector <int> _path,
	int _xst,
	int _yst, int _drops) {
		if (mp(_combos, mp(_drops, -(int)_path.size())) > mp(combos, mp(drops, -(int)path.size()))) {
			combos = _combos;
			drops = _drops;
			path = _path;
			xst = _xst;
			yst = _yst;
		}
	}
};

vector <int> path;
vector <int> xs;
vector <int> ys;
vvc init;
result Myres;


bool good(int x, int y, vvc& t) {
	return x >= 0 && y >= 0 && x < t.size() && y < t[x].size(); 
}

int TIMER = 19;
vector<vi> used(5, vi(6));


void dfs(int x, int y, vvc& t, vector < vi>& m) {
	used[x][y] = TIMER;
	for (int i = 0; i < 4; ++i) {
		int xx = x + dx[i];
		int yy = y + dy[i];
		if (good(xx, yy, t) && m[xx][yy] && t[x][y] == t[xx][yy] && used[xx][yy]!= TIMER) {
			dfs(xx, yy, t, m);
		}
	}
}

void solve(vvc& t) {
	int combos = 0;
	int drops = 0;

	while (true) {

		vector<vi> marked(6, vi(5));
		int marks = 0;
		for(int i = 0; i < 6; ++i) {
			for(int j = 0; j < 5; ++j) {
				if(good(i, j, t) && good(i, j + 1, t) && good(i, j + 2, t) && t[i][j] == t[i][j + 1] && t[i][j] == t[i][j + 2]) {
					for(int k = 0; k < 3; ++k) {
						marked[i][j + k] = true;
					}
				}
				if(good(i, j, t) && good(i + 1, j, t) && good(i + 2, j , t) && t[i][j] == t[i + 1][j] && t[i + 2][j] == t[i][j]) {
					for(int k = 0; k < 3; ++k) {
						marked[i + k][j] = true;
					}
				}
				if(marked[i][j]) 
					++marks;
			}
		}

		drops += marks;
		if(!marks)
			break;

		++TIMER;
		
		for(int i = 0; i < 5; ++i) {
			for(int j = 0; j < 6; ++j) {

				if(used[i][j] != TIMER && marked[i][j]) {
					
					combos += 1;
					dfs(i, j, t, marked);
				}

			}
		}

		vvc tt = vvc(6, vector<char>());

		for (int i = 0; i < t.size(); ++i) {
			for (int j = 0; j < t[i].size(); ++j) {
				if(!marked[i][j])
					tt[j].push_back(t[i][j]);
			}
		}
	}

	Myres.impr(combos, path, xs[0], ys[0], drops);
}

void gen(int x, int y) {
	vvc t = init;

	char tmp = t[xs[0]][ys[0]];

	for (int i = 0; i < xs.size() - 1; ++i) {
		t[xs[i]][ys[i]] = t[xs[i + 1]][ys[i + 1]];	
	}
	t[xs.back()][ys.back()] = tmp;

	solve(t);


	if (path.size() == 9) {
		return ;
	}

	for (int i = 0; i < 4; ++i) {
		int xx = x + dx[i];
		int yy = y + dy[i];
		if (good(xx, yy, init)) {
			path.push_back(i);
			xs.push_back(xx);
			ys.push_back(yy);
			
			gen(xx, yy);

			xs.pop_back();
			ys.pop_back();
			path.pop_back();
		}
	}
}

void solve() {
	Myres = result();
	++timerR;
	cout << "Case #" << timerR << ":\n";
	
	init = vvc( 6, vector <char> (5));

	for (int i = 0; i < init.size(); ++i) {
		for (int j = 0; j < init[i].size(); ++j) {
			cin >> init[j][i];
		}
	}

	
	reverse(init.begin(), init.end());

	for (int i = 0; i < init.size(); ++i) {
		for (int j = 0; j < init[i].size(); ++j) {
			xs.push_back(i);
			ys.push_back(j);

			gen(i, j);

			xs.pop_back();
			ys.pop_back();
		}
	}

	Myres.print();
}