#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}

bool print = 0;

#define int li

struct Edge {
	int from, to;
	int cap, flow;
};


vector<Edge> edges;
vector<vector<int>> g;


void add_edge(int from, int to, int c) {
	if(print)
		cout << from << ' ' << to << ' ' << c << "\n";
	Edge e = {from, to, c, 0};
	g[from].push_back(edges.size());
	edges.push_back(e);

	Edge e2 = {to, from, 0, 0};
	g[to].push_back(edges.size());
	edges.push_back(e2);
}


vi ptr;
int q[101010];

vi d;

bool bfs(int n, int s , int t) {
	int qh = 0, qt = 0;
	d.assign(n, -1);

	d[s] = 0;
	q[qt++] = s;

	while(qh != qt) {
		int v = q[qh++];
		for(int i = 0; i < g[v].size(); ++i) {
			Edge& e = edges[g[v][i]];
			if(e.cap == e.flow) 
				continue;
			if(d[e.to] == -1) {
				d[e.to] = d[v] + 1;
				q[qt++] = e.to;
			}
		}
	}
	

	return d[t] != -1;

}

bool dfs(int v, int to) {
	if(v == to)
		return true;
	for(signed& i = ptr[v]; i < g[v].size(); ++i) {
		int id = g[v][i];
		Edge& e = edges[id];
		if(e.cap == e.flow)
			continue;
		if(d[v] + 1 != d[e.to])
			continue;

		if(dfs(e.to, to)) {
			e.flow++;
			edges[id ^ 1].flow --;
			return true;
		}
	}
	return false;
}

int dinic(int n, int s, int t) {
	int flow = 0;
	while(bfs(n, s, t)) {
		ptr.assign(n, 0);
		while(dfs(s, t)) {
			++flow;
		}
	}
	return flow;
}


int timerR = 0;

int gcd(int q, int w) {
	while(w) {
		q %= w;
		swap(q, w);
	}
	return q;
}

bool cmp (const pair<int, int>& q, const pair<int, int>& w) {
	return q.first * w.second < w.first * q.second;
}

void solve() {
	++timerR;
	cout << "Case #" << timerR << ": ";

	int n;
	cin >> n;
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		--p[i];
	}

	vector<int> d(n);
	int m = 0;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			if (p[i] > p[j]) {
				++m;
				++d[i];
				++d[j];
			}
	
	int s = n, t = n + 1;

	vector<pair<int, int>> candy;
	for (int i = 0; i <= n * (n - 1) / 2; ++i)
		for (int j = 1; j <= n; ++j) {
			int up = i, down = j;
			int g = gcd(up, down);
			if (g > 1)
				continue;
			candy.push_back(mp(up, down));
		}

	sort(all(candy), cmp);

	int l = 0, r = candy.size();

	while (true) {
		
		int P, Q;

		int density = (l + r) / 2;

		if (l + 1 == r) {
			if (r == candy.size())
				break;
			pair<int, int> need = mp(candy[l].first * candy[r].second + candy[r].first * candy[l].second, candy[l].second * candy[r].second * 2);
			P = need.first;
			Q = need.second;
		}
		else {
			P = candy[density].first;
			Q = candy[density].second;
		}

		edges.clear();
		g.assign(n + 2, vector<int>());

		for (int i = 0; i < n; ++i) {
			add_edge(s, i, m * Q);
			add_edge(i, t, m * Q + 2 * P - d[i] * Q);
		}

		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j)
				if (p[i] > p[j]) {
					add_edge(i, j, Q);
					add_edge(j, i, Q);
				}

		int flow = dinic(n + 2, s, t);

		//cout << P / 1.0 / Q << ' ' << flow / 1.0 / Q << "\n";

		if (l + 1 == r) {
			if (flow < n * m * Q)
				l = r;
			break;
		}

		if (flow < n * m * Q)
			l = density;
		else
			r = density;
	}

	ld ans = candy[l].first / 1.0 / candy[l].second;
	

	cout << ans << "\n";
	
}