#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li


int timerR = 0;

int n, m;
vector <vector <int> > g;
vector <vector <int> > revg;

struct vert {
	int who;
	int verts[2];
	vert(){}
	vert(int who, int verts0, int verts1):who(who) {
		verts[0] = verts0;
		verts[1] = verts1;
	}
};

int states[2][101][101];
int deg[2][101][101];

void solve() {
	++timerR;
	cout << "Case #" << timerR << ": ";
	
	cin >> n >> m;
	g.assign(n, vector <int>());
	revg.assign(n, vector <int> ());

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		g[x].push_back(y);
		revg[y].push_back(x);
	}

	queue <vert> q;

	for (int who = 0; who < 2; ++who) {
		int verts[2];
		for (verts[0] = 0; verts[0] < n; ++verts[0]) {
			for (verts[1] = 0; verts[1] < n; ++verts[1]) {
				states[who][verts[0]][verts[1]] = -1;

				if (g[verts[who]].size() == 0) {
					states[who][verts[0]][verts[1]] = 0;
				}

				if (verts[0] == verts[1]) {
					states[who][verts[0]][verts[1]] = who;
				}

				if (states[who][verts[0]][verts[1]] != -1) {
					q.push(vert(who, verts[0], verts[1]));
				}

				deg[who][verts[0]][verts[1]] = g[verts[who]].size();
			}
		}
	}

	while (!q.empty()) {
		vert cur = q.front();
		q.pop();
		vert to;

		to.who = !cur.who;
		to.verts[0] = cur.verts[0];
		to.verts[1] = cur.verts[1];

		if (states[cur.who][cur.verts[0]][cur.verts[1]] == 0) {
				
			for (int i = 0; i < revg[cur.verts[to.who]].size(); ++i) {
				to.verts[to.who] = revg[cur.verts[to.who]][i];
				if (states[to.who][to.verts[0]][to.verts[1]] == -1) {
					states[to.who][to.verts[0]][to.verts[1]] = 1;
					q.push(to);
				}
			}

		}
		else {
			for (int i = 0; i < revg[cur.verts[to.who]].size(); ++i) {
				to.verts[to.who] = revg[cur.verts[to.who]][i];
				--deg[to.who][to.verts[0]][to.verts[1]];

				if (states[to.who][to.verts[0]][to.verts[1]] == -1 && deg[to.who][to.verts[0]][to.verts[1]] == 0) {
					states[to.who][to.verts[0]][to.verts[1]] = 0;
					q.push(to);
				}
			}
		}
	}


	int stx, sty;
	cin >> stx >> sty;
	--stx;
	--sty;
	if (states[0][stx][sty] != 0) {
		cout << "Yes\n";
	}
	else {
		cout << "No\n";
	}
}