#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MOD = 1000000007;

int powMod(int n, int k) {
    if (k == 0) {
        return 1;
    }

    int x = powMod(n, k / 2);

    x = ((long long)x * x) % MOD;

    if (k & 1) {
        x = ((long long)x * n) % MOD;
    }

    return x;
}

int binomial(int n, int k) {
    int ans = 1;

    for (int i = n; i > n - k; i--) {
        ans = ((long long)ans * i) % MOD;
    }

    for (int i = 1; i <= k; i++) {
        ans = ((long long)ans * powMod(i, MOD - 2)) % MOD;
    }

    return ans;
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;

    scanf("%d", &tests);

    for (int test_id = 0; test_id < tests; test_id++) {
        int n, m, k;

        scanf("%d %d %d", &n, &m, &k);

        int ans = binomial(m, k), bin = 1, cur = 0;

        for (int i = k; i >= 1; i--) {
            int sgn = -1 * ((k - i) & 1);
            if (!sgn) {
                sgn++;
            }

            cur = (cur + (long long)sgn * bin * i * powMod(i - 1, n - 1)) % MOD;
            bin = ((long long)bin * i) % MOD;
            bin = ((long long)bin * powMod(k - i + 1, MOD - 2)) % MOD;
        }

        printf("Case #%d: %d\n", test_id + 1, ((long long)ans * cur) % MOD);
    }

    return 0;
}
