#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MOD = 1000000007;
const int MAX_N = 1000005;

int inv[MAX_N];

int powMod(int n, int k) {
    if (k == 0) {
        return 1;
    }

    int x = powMod(n, k / 2);

    x = ((long long)x * x) % MOD;

    if (k & 1) {
        x = ((long long)x * n) % MOD;
    }

    return x;
}

int binomial(int n, int k) {
    int ans = 1;

    for (int i = n; i > n - k; i--) {
        ans = ((long long)ans * i) % MOD;
    }

    for (int i = 1; i <= k; i++) {
        ans = ((long long)ans * inv[i]) % MOD;
    }

    return ans;
}

int main() {
    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;

    for (int i = 1; i < MAX_N; i++) {
        inv[i] = powMod(i, MOD - 2);
    }

    scanf("%d", &tests);

    for (int test_id = 0; test_id < tests; test_id++) {
        int n, m, k;

        scanf("%d %d %d", &n, &m, &k);

        int ans = binomial(m, k), bin = 1, cur = 0;

        for (int i = k; i >= 1; i--) {
            int sgn;
            
            if ((k - i) & 1) {
                sgn = MOD - 1;
            } else {
                sgn = 1;
            }

            int add = ((long long)sgn * bin * i) % MOD;
            add = ((long long)add * powMod(i - 1, n - 1)) % MOD;
            cur = (cur + add) % MOD;
            bin = ((long long)bin * inv[k - i + 1]) % MOD;
            bin = ((long long)bin * i) % MOD;
        }

        ans = ((long long)ans * cur) % MOD;
        printf("Case #%d: %d\n", test_id + 1, ans);
    }

    return 0;
}
