#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MOD = 1000000007;
const int MAX_N = 1000005;

long long inv[MAX_N];

long long powMod(long long n, int k) {

    if (k == 0) {
        return 1;
    }
    long long res = 1;
    while (k > 0) {
        if (k & 1) {   
            res = (res * n) % MOD;
        }
        k >>= 1;
        n = (n * n) % MOD;
    }

    return res;
}

long long binomial(int n, int k) {
    long long ans = 1;

    for (int i = n; i > n - k; i--) {
        ans = (ans * i) % MOD;
    }

    for (int i = 1; i <= k; i++) {
        ans = (ans * inv[i]) % MOD;
    }

    return ans;
}

int main() {
    /*
       freopen("task.in", "r", stdin);
       freopen("task.out", "w", stdout);
     */

    int tests;

    for (int i = 1; i < MAX_N; i++) {
        inv[i] = powMod(i, MOD - 2);
    }

    scanf("%d", &tests);

    for (int test_id = 0; test_id < tests; test_id++) {
        int n, m, k;

        scanf("%d %d %d", &n, &m, &k);

        long long ans = binomial(m, k), bin = 1, cur = 0;

        for (int i = 0; i < k / 2 + (k & 1); i++) {
            int s1, s2;

            if ((k - i) & 1) {
                s1 = MOD - 1;
            } else {
                s1 = 1;
            }

            if (i & 1) {
                s2 = MOD - 1;
            } else {
                s2 = 1;
            }

            long long add = (s2 * bin) % MOD;
            add = (add * (k - i)) % MOD;
            add = (add * powMod(k - i - 1, n - 1)) % MOD;
            cur += add;

            if (cur >= MOD) {
                cur -= MOD;
            }

            if (i) {
                add = (s1 * bin) % MOD;
                add = (add * i) % MOD;
                add = (add * powMod(i - 1, n - 1)) % MOD;
                cur += add;

                if (cur >= MOD) {
                    cur -= MOD;
                }

            }

            bin = (bin * inv[i + 1]) % MOD;
            bin = (bin * (k - i)) % MOD;
        }

        if (!(k & 1)) {
            int s;

            if ((k / 2) & 1) {
                s = MOD - 1;
            } else {
                s = 1;
            }

            long long add = (s * bin) % MOD;
            add = (add * (k / 2)) % MOD;
            add = (add * powMod(k / 2 - 1, n - 1)) % MOD;
            cur += add;

            if (cur >= MOD) {
                cur -= MOD;
            }
        }

        ans = ((long long)ans * cur) % MOD;

        printf("Case #%d: %d\n", test_id + 1, ans);
    }

    return 0;
}
