#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>
#define pb push_back

const int alpha = 26;

struct Node
{
	int len;
	int link;
	i64 cnt;
	int next[alpha];
	Node(int _len, int _link) : len(_len), link(_link), cnt(0)
	{
		forn(j, alpha)
			next[j] = -1;
	}
};

vector <Node> tree[2];

void build(string & s, int number)
{
	forn(j, s.length())
		s[j] -= 'a';
	tree[number].pb(Node(0, 1));
	tree[number].pb(Node(-1, 1));
	int cur = 0;
	forn(j, s.length())
	{
		int letter = s[j];
		//while(cur > 1 && (j - tree[number][cur].len - 1 < 0 || letter != s[j - tree[number][cur].len - 1]))
		while((j - tree[number][cur].len - 1 < 0 || letter != s[j - tree[number][cur].len - 1]))
		//while(j - tree[number][cur].len - 1 < 0 || letter != s[j - tree[number][cur].len - 1])
			cur = tree[number][cur].link;
		if (tree[number][cur].next[letter] == -1)
		{
			tree[number].pb(Node(tree[number][cur].len + 2, -1));
			
			//int new_link = cur;
			if (cur == 1)
			{
				tree[number][tree[number].size() - 1].link = 0;
			}
			else
			{
				int new_link = tree[number][cur].link;
				//while(new_link > 1 && letter != s[j - tree[number][new_link].len - 1])
				//while( new_link > 1 && (j - tree[number][new_link].len - 1 < 0 || letter != s[j - tree[number][new_link].len - 1]))
				
				while((j - tree[number][new_link].len - 1 < 0 || letter != s[j - tree[number][new_link].len - 1]))
					new_link = tree[number][new_link].link;
				tree[number][tree[number].size() - 1].link = tree[number][new_link].next[letter];
			}
			tree[number][cur].next[letter] = tree[number].size() - 1;
			cur = tree[number].size() - 1;
		}
		else
		{
			cur = tree[number][cur].next[letter];
		}
		tree[number][cur].cnt++;
	}
	for (int j = tree[number].size() - 1; j >= 0; j--)
		tree[number][tree[number][j].link].cnt += tree[number][j].cnt;
	/*forn(j, tree[number].size())
	{
		printf("j = %d\n", j);
		printf("len = %d link = %d cnt = %lld\n", tree[number][j].len, tree[number][j].link, tree[number][j].cnt);
		forn(i, alpha) if (tree[number][j].next[i] != -1)
			printf("next[%d] = %d\n", i, tree[number][j].next[i]);
	}
	printf("======================\n");*/
}

i64 answer;

void go(int v0, int v1)
{
	if (v0 != 1 && v0 != 0)
		answer += tree[0][v0].cnt * tree[1][v1].cnt;
	forn(j, alpha)
		if (tree[0][v0].next[j] != -1 && tree[1][v1].next[j] != -1)
			go(tree[0][v0].next[j], tree[1][v1].next[j]);
}

void solve(int test_number)
{
	tree[0].clear();
	tree[1].clear();
	string s1, s0;
	cin >> s0;
	build(s0, 0);
	cin >> s1;
	build(s1, 1);
	answer = 0;
	go(0, 0);
	go(1, 1);
	printf("Case #%d: ", test_number);
	cout << answer << endl;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	forn(test, tests)
		solve(test + 1);
}