#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pb push_back
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

#define WIN 1
#define LOSE 2

struct Elem
{
	int pos0, pos1, move, state;
	Elem(int _pos0, int _pos1, int _move, int _state) : pos0(_pos0), pos1(_pos1), move(_move), state(_state) {}
};

const int maxn = 105;

vi back_edges[maxn];
int cnt[maxn][maxn][2];
int deg[maxn];

void solve(int test_number)
{
	int n, m;
	scanf("%d%d", &n, &m);
	fore(j, 1, n)
	{
		back_edges[j].clear();
		deg[j] = 0;
	}
	forn(j, m)
	{
		int fr, to;
		scanf("%d%d", &fr, &to);
		back_edges[to].pb(fr);
		deg[fr]++;
	}
	int start0, start1;
	scanf("%d%d", &start0, &start1);
	queue <Elem> order;
	fore(i, 1, n)
		fore(j, 1, n)
			forn(move, 2)
			{
				if (i == j)
				{
					if (move == 1)
						order.push(Elem(i, j, 1, WIN));
					else order.push(Elem(i, j, 0, LOSE));
				}
				cnt[i][j][move] = (move == 0 ? deg[i] : deg[j]);
			}
	printf("Case #%d: ", test_number);
	while(!order.empty())
	{
		Elem e = order.front();
		if (e.pos0 == start0 && e.pos1 == start1 && e.move == 0)
		{
			if (e.state == WIN)
				printf("Yes\n");
			else printf("No\n");
			return;
		}
		order.pop();
		int ver = (e.move == 0 ? e.pos1 : e.pos0);
		//int ver = (e.move == 0 ? e.pos0 : e.pos1);
		//int rival = (e.move == 0 ? e.pos1 : e.pos0);
		
		forn(j, back_edges[ver].size())
		{
			int u = back_edges[ver][j];
			int t0 = (e.move == 0 ? e.pos0 : u);
			int t1 = (e.move == 0 ? u : e.pos1);
			if (e.state == WIN)
			{
				cnt[t0][t1][1 - e.move]--;
				if (cnt[t0][t1][1 - e.move] == 0)
					order.push(Elem(t0, t1, 1 - e.move, LOSE));
			}
			else
			{
				order.push(Elem(t0, t1, 1 - e.move, WIN));
			}
		}
	}
	printf("Yes\n");	
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	forn(test, tests)
		solve(test + 1);
}