#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>
#define uint unsigned int

struct node {
	int next[2];
	bool leaf;
};

node a[2000100];
int sz;

inline void initNode(int i) {
	a[i].next[0] = a[i].next[1] = -1;
	a[i].leaf = false;
}

inline void init() {
	sz = 1;
	initNode(0);
}

int n;
vector<pair<uint, int> > res;

void print(uint x)
{
	printf("%d.%d.%d.%d", (x >> 24), ((x & ((1 << 24) - 1)) >> 16), ((x & ((1 << 16) - 1)) >> 8), (x & ((1 << 8) - 1)));
}

void dfs(int v, uint cur = 0, int lev = 0) {
	//cerr << v << ' ' << a[v].leaf << endl;
	if (a[v].leaf == true)
		return;
	if (a[v].next[0] == -1 && a[v].next[1] == -1) {
		return;
	}
	if (a[v].next[0] != -1) {
		dfs(a[v].next[0], cur, lev + 1);
	}
	if (a[v].next[1] != -1) {
		dfs(a[v].next[1], cur + ((uint)1 << (31 - lev)), lev + 1);
	}
	if (a[v].next[0] == -1) {
		res.push_back(mp(cur, lev + 1));
	}
	if (a[v].next[1] == -1) {
		res.push_back(mp(cur + ((uint)1 << (31 - lev)), lev + 1));
	}
}

void solve(int test) {
	res.clear();
	printf("Case #%d:\n", test);
	scanf("%d", &n);
	if (n == 0) {
		printf("1\n");
		printf("0.0.0.0/0\n");
		return;
	}
	init();
	bool flag = false;
	for (int i = 0; i < n; i++) {
		uint a1, a2, a3, a4, len;
		scanf("%d.%d.%d.%d/%d\n", &a1, &a2, &a3, &a4, &len);
		if (len == 0) {
			flag = true;
		}
		uint msk = (a1 << 24) + (a2 << 16) + (a3 << 8) + (a4);
		//cerr << msk << endl;
		int cur = 31;
		int pos = 0;
		for (int i = 0; i < len; i++) {
			uint cur_bit = msk & ((uint)1 << cur);
			int c;
			if (cur_bit == 0) 
				c = 0;
			else
				c = 1;
			//cerr << c << endl;
			if (a[pos].next[c] != -1)
				pos = a[pos].next[c];
			else {
				initNode(sz);
				a[pos].next[c] = sz;
				pos = a[pos].next[c];
				sz++;
			}
			cur--;
		}
		// cerr << pos << ' ' << sz << endl;
		a[pos].leaf = true;
	}
	if (flag) {
		printf("0\n");
		return;
	}
	dfs(0);
	printf("%d\n", res.size());
	for (int i = 0; i < (int)res.size(); i++) {
		//cerr << res[i].first << ' ' << res[i].second << endl;
		print(res[i].first);
		printf("/%d\n", res[i].second);
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d\n", &n);
	for (int i = 0; i < n; i++)
		solve(i + 1);
}