#include <bits/stdc++.h>
using namespace std;
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define in(n) int n = nxt()
inline int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}
typedef long long ll;
typedef long double ld;
typedef pair<int, int> PII;
typedef pair<ll, ll> PLL;

template <class T>
T gcd(T a, T b) {
    return b > 0 ? gcd(b, a % b) : a;
}

struct edge {
    int from;
    int to;
    int u;
    int f;
};

const int M = 5000;
const int N = 200;
edge e[M + M];
vector <int> g[N];
int q[N];

int sz = 0;

void addEdge (int a, int b, int c) {
    edge A = edge{a, b, c, 0};
    edge B = edge{b, a, 0, 0};
    g[a].pb(sz);
    e[sz++] = A;
    g[b].pb(sz);
    e[sz++] = B;
}

int p[N];
char used[N];
int n, m;

bool bfs(int s, int t) {
    memset(used, 0, n * sizeof(char));
    int q1 = 0, q2 = 0;
    q[q1++] = s;
    used[s] = 1;
    while (q1 != q2) {
        int v = q[q2++];
        for (int E : g[v]) {
            edge & ee = e[E];
            if (ee.f != ee.u && !used[ee.to]) {
                q[q1++] = ee.to;
                p[ee.to] = E;
                used[ee.to] = 1;
            }
        }
    }
    return used[t];
}

int relax(int s, int t) {
    int addFlow = INT_MAX;
    for (int cur = t; cur != s; cur = e[p[cur]].from) {
        int E = p[cur];
        addFlow = min(addFlow, e[E].u - e[E].f);
    }
    for (int cur = t; cur != s; cur = e[p[cur]].from) {
        int E = p[cur];
        e[E].f += addFlow;
        e[E ^ 1].f -= addFlow;
    }
    return addFlow;
}

int a[M], b[M];
int d[N];
int n1, m1;

bool check(pair <int, int> G) {
    sz = 0;
    n = n1 + 2;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    int s = n1, t = n1 + 1;
    for (int i = 0; i < n1; ++i) {
        addEdge(s, i, m1 * G.second);
        addEdge(i, t, m1 * G.second + 2 * G.first - d[i] * G.second);
    }
    for (int i = 0; i < m1; ++i) {
        //cerr << a[i] << " " << b[i] << endl;
        addEdge(a[i], b[i], G.second);
        addEdge(b[i], a[i], G.second);
    }
    //cerr << endl;
    int flow = 0;

    while (bfs(s, t)) {
        flow += relax(s, t);
    }
//    cerr << "\n";
//    cerr << flow << endl;
//    cerr << "ASD" << endl;
//    cerr << m1 << " " << G.second << endl;
//    for (int i = 0; i < n; ++i) {
//        cerr << (int)used[i] << " ";
//    }
//    cerr << endl;
    for (int i = 0; i < n; ++i) {
        if (i != s && used[i]) {
            return true;
        }
    }
    return false;
}

void solve() {
    in(t);
    int cc = 0;
    cout << setprecision(10) << fixed;
    while (t--) {
        cout << "Case #" << ++cc << ": ";
        n1 = nxt();
        m1 = 0;
        int v[n1];
        for (int i = 0; i < n1; ++i) {
            v[i] = nxt() - 1;
            d[i] = 0;
        }
        for (int i = 0; i < n1; ++i) {
            for (int j = i + 1; j < n1; ++j) {
                if (v[j] < v[i]) {
                    a[m1] = i;
                    b[m1] = j;
                    d[i]++;
                    d[j]++;
                    //cerr << i << " " << j << endl;
                    m1++;
                }
            }
        }
        //cerr << check(mp(5, 4)) << endl;
        //exit(0);
//        for (int i = 0; i < n1; ++i) {
//            cerr << d[i] << endl;
//        }

        if (m1 == 0) {
            puts("0.0");
            continue;
        }
        pair <int, int> c[n1 * m1 + 1];
        int s = 0;
        c[s++] = mp(0, 1);
        for (int i = 0; i < n1; ++i) {
            for (int j = 0; j < m1; ++j) {
                c[s++] = mp(j + 1, i + 1);
            }
        }
        sort(c, c + s, [&](pair <int, int> u, pair <int, int> v) {
            return u.first * v.second < u.second * v.first;
        });

        int l = 0, r = s - 1;

        while (l < r) {
            int mid = (l + r + 1) / 2;
            if (check(c[mid])) {
                l = mid;
            } else {
                r = mid - 1;
            }
        }
        check(c[l]);
        int z = 0;
        for (int i = 0; i < n1; ++i) {
            z += used[i];
        }
        int y = 0;
        for (int i = 0; i < m1; ++i) {
            if (used[a[i]] && used[b[i]]) {
                ++y;
            }
        }
        cout << (double)y / z << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

//    gen();
    solve();
    return 0;
}
