#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 110;

struct Input {
	int n;
	int a[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			scanf("%d", &a[i]);
			--a[i];
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ld ans;
	void write () {
		cout << ans << "\n";
	}
	
	virtual void clear () {}
	virtual void solve () {}
};

struct Edge {
	int u, v, c, f;
	Edge (int u = 0, int v = 0, int c = 0, int f = 0): u(u), v(v), c(c), f(f) {
	}
};

const int inf = 1000000000;

struct Solution: Data {
	int m;
	ve<pii> he;
	int deg[N];
	ve<pii> g[N + 2];
	ve<Edge> ed;
	int sz;
	int d1[N];
	queue<int> q;
	int p[N];
	int st, fn;
	bool use[N];
	
	bool bfs () {
		while (!q.empty())
			q.pop();
		q.push(st);
		forn(i, sz)
			d1[i] = inf;
		d1[st] = 0;
		// debug(mp(st, fn));
		while (!q.empty()) {
			int k = q.front();
			q.pop();
			forn(i, g[k].size()) {
				int to = g[k][i].fs;
				int idx = g[k][i].sc;
				if (d1[to] != inf || ed[idx].c - ed[idx].f <= 0)
					continue;
				d1[to] = d1[k] + 1;
				q.push(to);	
			}
	 	}
	 	return d1[fn] < inf;
	}
	
	int dfs (int v, int minn = inf) {
		if (v == fn)
			return minn;
		use[v] = 1;
		for (int i = p[v]; i < (int)g[v].size(); ++i) {
			int to = g[v][i].fs, idx = g[v][i].sc;
			if (use[to] || d1[to] != d1[v] + 1 || ed[idx].c - ed[idx].f <= 0)
				continue;
			int k = dfs(to, min(minn, ed[idx].c - ed[idx].f));
			if (k > 0) {
				ed[idx].f += k;
				ed[idx ^ 1].f -= k;
				return k;
		 	}
		 	p[v]++;		
		}
		return 0;
	}
	
	void addEdge (int u, int v, int c) {
		g[u].pb(mp(v, sz(ed)));
		ed.pb(Edge(u, v, c));
	}
	
	static const int inf = 1e9;
	void pushFlow () {
		int v = n + 1;
		int mn = inf;
		while (v != n) {
			int e = from[v];
			int u = ed[e].u;
			umn(mn, ed[e].c - ed[e].f);
			v = u;
		}
		v = n + 1;
		while (v != n) {
			int e = from[v];
			int u = ed[e].u;
			ed[e].f += mn;
			ed[e ^ 1].f -= mn;
			v = u;
		}
	}
	
	int d[N + 2], from[N + 2];
    vi findPath () {
		int k = n + 2;
		fill(d, d + k, inf);
		memset(from, -1, sizeof from);
		d[n] = 0;
		queue<int> t;
		t.push(n);
		vi cut;
		while (!t.empty()) {
			int u = t.front();
			cut.pb(u);
			if (u == n + 1) {
				break;
			}
			t.pop();
			forn (i, sz(g[u])) {
				int e = g[u][i].sc;
				if (ed[e].f == ed[e].c) {
					continue;
				}
				int v = g[u][i].fs;
				if (umn(d[v], d[u] + 1)) {
					from[v] = e;
					t.push(v);
				}
			}
		}
		
		return cut;
	}
	
	int gcd (int a, int b) {
		return b ? gcd(b, a % b) : a;
	}
	
	bool check (pii al) {
		int d = gcd(al.fs, al.sc);
		al.fs /= d;
		al.sc /= d;
		
		forn (i, n + 2) {
			g[i].clear();
		}
		ed.clear();
		
		forn (i, n) {
			addEdge(n, i, m * al.sc);
			addEdge(i, n, 0);
			addEdge(i, n + 1, m * al.sc + 2 * al.fs - deg[i] * al.sc);
			addEdge(n + 1, i, 0);
		}
		
		forn (i, sz(he)) {
			addEdge(he[i].fs, he[i].sc, 1 * al.sc);
			addEdge(he[i].sc, he[i].fs, 1 * al.sc);
		}
		
		/*while (findPath().back() == n + 1) {
			pushFlow();
		}*/
		// debug('!');
		while (bfs()) {
			memset(use, 0, sizeof(use));
			memset(p, 0, sizeof(p));
			while (dfs(st) > 0)
				memset(use, 0, sizeof(use));
		}
		
		return sz(findPath()) != 1;
	}
		
	void solve () {
		memset(deg, 0, sizeof deg);
		m = 0;
		sz = n + 2;
		st = n, fn = n + 1;
		forn (i, n) {
			forn (j, n) {
				if (i < j && a[i] > a[j]) {
					he.pb(mp(i, j));
					++m;
					++deg[i];
					++deg[j];
				}
			}
		}
	
		if (sz(he) == 0) {
			ans = 0;
			return;
		}
		
		debug(he);
		
		ve<pii> vals;
		for (int i = 1; i <= n; ++i) {
			for (int j = 0; j <= m; ++j) {	
				vals.pb(mp(j, i));
			}
		}
		sort(all(vals), [](pii const & a, pii const & b) {
			return a.fs * b.sc < b.fs * a.sc;
		});
		vals.erase(unique(all(vals), [](pii const & a, pii const & b) {return a.fs * b.sc == b.fs * a.sc;}), vals.end());
//		debug(vals);
		int l = -1, r = sz(vals);
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (check(vals[m])) {
				l = m;
			}
			else {
				r = m;
			}
		}
		debug(check(mp(2, 1)));
		debug(vals[l]);
		ans = ld(vals[r].fs) / vals[r].sc;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("c.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	int t;
	cin >> t;
	forn(i, t) {
		sol.read();
		sol.solve();
		printf("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}
	return 0;
}
