#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 1005000;
const int MOD = 1000000007;

int d[MAXN];

int
getPow(int base, int st)
{
	int res = 1;
	while (st) {
		if (st & 1) {
			res = 1ll * res * base % MOD;
		}
		st /= 2;
		base = 1ll * base * base % MOD;
	}
	return res;
}

int fact[MAXN], rev[MAXN];

int
getC(int m, int k)
{
	int res = 1;
	for (int i = 1; i <= k; ++i) {
		res = 1ll * res * (m - i + 1) % MOD;
		res = 1ll * res * getPow(i, MOD - 2) % MOD;
	}
	return res;
}

int
binom(int n, int k)
{
	int res = 1ll * fact[n] * rev[k] % MOD;
	return 1ll * res * rev[n - k] % MOD;
}

void
process(int id)
{
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	int mult = getC(m, k);
	int res = 0;
	if (n == 1) {
		res = (k > 1) ? 0 : 1;
	} else {
		/*d[1] = 0;
		for (int curK = 2; curK <= k; ++curK) {
			d[curK] = 1ll * curK * getPow(curK - 1, n - 1) % MOD;
			for (int j = curK - 1; j >= 2; --j) {
				d[curK] = (d[curK] + MOD - 1ll * d[j] * binom(curK, j) % MOD) % MOD;
			}
		}*/
		res = 0ll;
		int mult = 1;
		for (int i = k - 1; i >= 1; --i) {
			int coeff = 1ll * getPow(i, n - 2) * binom(k - 2, i - 1) % MOD;
			if (mult < 0) {
				res = (res - coeff + MOD) % MOD;
			} else {
				res = (res + coeff) % MOD;
			}
			mult *= -1;
		}
		res = 1ll * res * k % MOD;
		res = 1ll * res * (k - 1) % MOD;
		//printf("Expected %d, reality %d\n", d[k], res);
	}
	res = 1ll * res * mult % MOD;
	printf("Case #%d: %d\n", id, res);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	fact[0] = 1;
	for (int i = 1; i < MAXN; ++i) {
		fact[i] = 1ll * i * fact[i - 1] % MOD;
	}
	for (int i = 0; i < MAXN; ++i) {
		rev[i] = getPow(fact[i], MOD - 2);
	}
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process(i + 1);
	}
	return 0;
}