#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 
#include <numeric>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 500100;

char s[2][MAXN];
char buf[MAXN];
int oddLen[2][MAXN], evenLen[2][MAXN];
int bufLen = 0;
int lens[2];
int sufArr[MAXN], lcp[MAXN], rpos[MAXN];

void
calcLens(char *s, int *odd, int *even, int len)
{
	--s;
	for (int i = 0; i <= len; ++i) {
		odd[i] = even[i] = 0;
	}
	{ // odd len
		int l = 0, r = 0;
		for (int i = 1; i <= len; ++i) {
			// 1-based index
			int k = 1;
			if (r >= i) {
				k = min(r - i + 1, odd[l + (r - i)]);
			}
			while (i - k > 0 && k + i <= len && s[i + k] == s[i - k]) {
				++k;
			}
			odd[i] = k;
			if (i + odd[i] - 1 > r) {
				r = i + odd[i] - 1;
				l = i - odd[i] + 1;
			}
		}
	}
	{ // even len
		int l = 0, r = -1;
		for (int i = 1; i <= len; ++i) {
			// 1-based index
			int k = 0;
			if (r >= i) {
				k = min(r - i + 1, even[l + (r - i) + 1]);
			}
			while (i - k - 1 > 0 && k + i <= len && s[i + k] == s[i - k - 1]) {
				++k;
			}
			even[i] = k;
			if (even[i] != 0 && i + even[i] - 1 >= r) {
				r = i + even[i] - 1;
				l = i - even[i];
			}
		}
	}
	for (int i = 0; i < len; ++i) {
		odd[i] = odd[i + 1];
		even[i] = even[i + 1];
	}
	/*printf("\n");
	puts(s + 1);
	for (int i = 0; i < len; ++i) {
		printf("%d ", odd[i]);
	}
	puts("");
	for (int i = 0; i < len; ++i) {
		printf("%d ", even[i]);
	}
	puts("");*/
}

int hcnt[2][MAXN];
int col[2][MAXN];
int bufSA[2][MAXN];

void
calcSufArr(char *s, int len)
{
	int *ocol = col[0], *ncol = col[1];
	int *SA = bufSA[0], *nSA = bufSA[1];
	for (int i = 0; i < len; ++i) {
		SA[i] = i;
		ocol[i] = s[i];
	}
	int cnt = 256;
	int curk = 0;
	int *h = hcnt[0];
	while (curk < len) {
		fill(h, h + cnt + 1, 0);
		for (int i = 0; i < len; ++i) {
			SA[i] = (SA[i] - curk + len) % len;
			h[ocol[SA[i]] + 1]++;
		}
		partial_sum(h, h + cnt + 1, h);
		for (int i = 0; i < len; ++i) {
			nSA[h[ocol[SA[i]]]++] = SA[i];
		}
		cnt = 0;
		for (int i = 0; i < len; ++i) {
			ncol[nSA[i]] = cnt;
			if (i != len - 1 &&
				(ocol[nSA[i]] != ocol[nSA[i + 1]] ||
				ocol[(nSA[i] + curk) % len] != ocol[(nSA[i + 1] + curk) % len])) {
					++cnt;
			}
		}
		curk *= 2;
		if (curk == 0) {
			++curk;
		}
		swap(SA, nSA);
		swap(ocol, ncol);
	}
	for (int i = 0; i < len; ++i) {
		sufArr[i] = SA[i];
	}
	for (int i = 0; i < len; ++i) {
		lcp[i] = 0;
	}
	int k = 0;
	for (int i = 0; i < len; ++i) {
		rpos[sufArr[i]] = i;
	}
	for (int i = 0; i < len -1; ++i) {
		k = max(0, k - 1);
		int cPos = rpos[i];
		if (cPos == len - 1) {
			k = 0;
			continue;
		}
		while (s[i + k] == s[sufArr[cPos + 1] + k]) {
			k++;
		}
		lcp[cPos] = k;
	}
}

struct Event
{
	int type; // 0 - merge or 1 - add
	int id;
	int k1, k2, k3, k4;
	Event(int t, int i, int k1k = 0, int k2k = 0, int k3k = 0, int k4k = 0) 
		: type(t), id(i), k1(k1k), k2(k2k), k3(k3k), k4(k4k) {}
};

int par[MAXN], rnk[MAXN];
int prv[MAXN];
int k1[MAXN], k2[MAXN], k3[MAXN], k4[MAXN];

void
link(int x, int y)
{
	if (rnk[x] >= rnk[y]) {
		par[y] = x;
	} else {
		par[x] = y;
	}
	k1[par[x]] = k1[x] + k1[y];
	k2[par[x]] = k2[x] + k2[y];
	k3[par[x]] = k3[x] + k3[y];
	k4[par[x]] = k4[x] + k4[y];
	if (rnk[x] == rnk[y]) ++rnk[x];
}

ll
getSum(int pos)
{
	return 1ll * k1[pos] * k2[pos] + 1ll * k3[pos] * k4[pos];
}

inline int getPar(int x)
{
	if (par[x] != x) par[x] = getPar(par[x]);
	return par[x];
}

ll
getAns(int *lcp, int p1, int p2)//, int *arr1, int *arr2)
{
	int len = p2 + 1;
	vector< vector< Event > > sm(len + 1);
	for (int i = 0; i < len; ++i) {
		prv[i] = i - 1;
		par[i] = i;
		rnk[i] = 0;
		k1[i] = k2[i] = 0;
		k3[i] = k4[i] = 0;
	}
	for (int i = 0; i < len - 1; ++i) {
		sm[lcp[i]].push_back(Event(0, i));
	}
	for (int i = 0; i < p1; ++i) {
		sm[evenLen[0][i]].push_back(Event(1, rpos[i], 1, 0, 0, 0));
	}
	for (int i = 0; i < p2 - p1 - 1; ++i) {
		sm[evenLen[1][i]].push_back(Event(1, rpos[p1 + i + 1], 0, 1, 0, 0));
	}
	for (int i = 0; i < p1; ++i) {
		sm[oddLen[0][i]].push_back(Event(1, rpos[i], 0, 0, 1, 0));
	}
	for (int i = 0; i < p2 - p1 - 1; ++i) {
		sm[oddLen[1][i]].push_back(Event(1, rpos[p1 + i + 1], 0, 0, 0, 1));
	}
	//sort(sm.rbegin(), sm.rend());
	ll ans = 0ll;
	ll curSum = 0ll;
	for (int curL = len; curL >= 1; --curL) {
		for (int curPos = 0; curPos < int(sm[curL].size()); ++curPos) {
			if (sm[curL][curPos].type == 0) {
				int pos = sm[curL][curPos].id;
				int curPar = getPar(pos);
				int prevPar = getPar(pos + 1);
				curSum -= getSum(curPar) + getSum(prevPar);
				link(curPar, prevPar);
				curPar = getPar(pos);
				curSum += getSum(curPar);
			} else {
				int pos = sm[curL][curPos].id;
				int curPar = getPar(pos);
				curSum -= getSum(curPar);
				k1[curPar] += sm[curL][curPos].k1;
				k2[curPar] += sm[curL][curPos].k2;
				k3[curPar] += sm[curL][curPos].k3;
				k4[curPar] += sm[curL][curPos].k4;
				curSum += getSum(curPar);
			}
		}
		ans += curSum;
	}
	return ans;
}

void
process(int id)
{
	printf("Case #%d: ", id + 1);
	for (int i = 0; i < 2; ++i) {
		scanf(" %s", s[i]);
		lens[i] = strlen(s[i]);
		calcLens(s[i], oddLen[i], evenLen[i], lens[i]);
	}
	for (int i = 0; i < lens[0] + lens[1] + 4; ++i) {
		buf[i] = 0;
	}
	buf[lens[0] + lens[1] + 4] = 0;
	char *ptr = buf;
	for (int i = 0; i < lens[0]; ++i) {
		*ptr++ = s[0][i];
	}
	*ptr++ = '#';
	for (int i = 0; i < lens[1]; ++i) {
		*ptr++ = s[1][i];
	}
	*ptr++ = '$';
	calcSufArr(buf, ptr - buf);
	ll res = 0ll;
	res += getAns(lcp, lens[0], lens[1] + lens[0] + 1);/*, evenLen[0], evenLen[1]);
	res += getAns(lcp, lens[0], lens[1] + lens[0] + 1, oddLen[0], oddLen[1]);*/
	printf("%lld\n", res);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process(i);
	}
	return 0;
}