#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 111;

typedef pair< pii, int > piii;

bool used[MAXN][MAXN][2];
int val[MAXN][MAXN][2];
int cnt[MAXN][MAXN][2];
int n, m;
vector< vector< int > > g, gs;
piii q[MAXN * MAXN * 2];
int qh, qt;
int x, y;

void
add(int f, int s, int vl)
{
	used[f][s][vl] = true;
	q[qt++] = mp(mp(f, s), vl);
}

void
extract(int id, int &f, int &s, int &vl)
{
	f = q[id].first.first;
	s = q[id].first.second;
	vl = q[id].second;
}

void
process(int id)
{
	scanf("%d%d", &n, &m);
	g.clear();
	g.resize(n + 1);
	gs.clear();
	gs.resize(n + 1);
	for (int i = 0; i < m; ++i) {
		int b, e;
		scanf("%d%d", &b, &e);
		g[b].push_back(e);
		gs[e].push_back(b);
	}
	scanf("%d%d", &x, &y);
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			used[i][j][0] = used[i][j][1] = false;
			val[i][j][0] = val[i][j][1] = -1;
			cnt[i][j][0] = cnt[i][j][1] = 0;
		}
	}
	qh = qt = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			cnt[i][j][0] = int(g[i].size());
			cnt[i][j][1] = int(g[j].size());
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			if (i == j) {
				val[i][j][0] = 0;
				val[i][j][1] = 1;
				add(i, j, 0);
				add(i, j, 1);
			} else {
				if (cnt[i][j][0] == 0) {
					val[i][j][0] = 0;
					add(i, j, 0);
				}
				if (cnt[i][j][1] == 0) {
					val[i][j][1] = 0;
					add(i, j, 1);
				}
			}
		}
	}
	while (qh < qt) {
		int i, j, pl;
		extract(qh, i, j, pl);
		++qh;
		if (pl == 0) { // 1 moved before
			for (vector< int >::iterator it = gs[j].begin(); it != gs[j].end(); ++it) {
				int to_v = *it;
				--cnt[i][to_v][1];
				if (!used[i][to_v][1]) {
					if (!val[i][j][0]) {
						val[i][to_v][1] = 1;
						add(i, to_v, 1);
					} else if (cnt[i][to_v][1] == 0) {
						val[i][to_v][1] = 0;
						add(i, to_v, 1);
					}
				}
			}
		} else { // 0 moved before
			for (vector< int >::iterator it = gs[i].begin(); it != gs[i].end(); ++it) {
				int to_v = *it;
				--cnt[to_v][j][0];
				if (!used[to_v][j][0]) {
					if (!val[i][j][1]) {
						val[to_v][j][0] = 1;
						add(to_v, j, 0);
					} else if (cnt[to_v][j][0] == 0) {
						val[to_v][j][0] = 0;
						add(to_v, j, 0);
					}
				}
			}
		}
	}
	printf("Case #%d: ", id);
	if (val[x][y][0] == 0) {
		puts("No");
	} else {
		puts("Yes");
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process(i + 1);
	}


	return 0;
}