#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 111;
const int iters = 45;

int step = 0, t;
int used[N], d[N];
int p[N], q[N], a[N], ptr[N], deg[N];
double c[N][N], f[N][N];

void dfs(int v) {
	used[v] = step;
	if (v == t) {
		return;
	}
	while (ptr[v] <= t) {
		if (c[v][ptr[v]] - f[v][ptr[v]] <= 0 || d[ptr[v]] != d[v] + 1 || used[ptr[v]] == step) {
			++ptr[v];
			continue;
		}
		p[ptr[v]] = v;
		dfs(ptr[v]);
		if (used[t] == step) {
			return;
		}
		++ptr[v];
	}
}

inline void solve() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	int s = n;
	t = n + 1;
	double l = 0, r = n;
	for (int it = 0; it < iters; ++it) {
		double mid = (l + r) / 2;
		for (int i = 0; i <= t; ++i) {
			for (int j = 0; j <= t; ++j) {
				c[i][j] = f[i][j] = 0;
			}
		}
		for (int i = 0; i < n; ++i) {
			deg[i] = 0;
		}
		double flow = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if (a[i] > a[j]) {
					++deg[i];
					++deg[j];
					flow += 2.0;
					c[i][j] = c[j][i] = 1;
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			c[s][i] = deg[i];
			c[i][t] = 2 * mid;
		}
		for (; flow > -eps;) {
			for (int i = 0; i <= t; ++i) {
				d[i] = inf;
			}
			d[s] = 0;
			int l = 0, r = 1;
			q[0] = s;
			while (l < r) {
				int v = q[l++];
				for (int i = 0; i <= t; ++i) {
					if (c[v][i] - f[v][i] > 0 && d[i] > d[v] + 1) {
						d[i] = d[v] + 1;
						q[r++] = i;
					}
				}
			}
			if (d[t] == inf) {
				break;
			}
			for (int i = 0; i <= t; ++i) {
				ptr[i] = 0;
			}
			for (; flow > -eps;) {
				++step;
				dfs(s);
				if (used[t] != step) {
					break;
				}
				double can = inf;
				for (int i = t; i != s; i = p[i]) {
					can = min(can, c[p[i]][i] - f[p[i]][i]);
				}
				flow -= can;
				for (int i = t; i != s; i = p[i]) {
					f[p[i]][i] += can;
					f[i][p[i]] -= can;
				}
			}
		}
		if (flow > 0) {
			l = mid;
		} else {
			r = mid;
		}
	}
	printf("%.18lf\n", (l + r) / 2);
}

int main() {
#ifdef LOCAL42
#define TASK "C"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		printf("Case #%d: ", i + 1);
		solve();
	}
	return 0;
}
