#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(4e5) + 100;

struct node {

	bool odd;
	int link, len;
	ll cnt1, cnt2;
	int next[27];

};

int sz, cur;
node v[2 * N];
char s[2 * N], t[N];

inline void init() {
	sz = 2;
	for (int i = 0; i < 27; ++i) {
		v[0].next[i] = v[1].next[i] = -1;
	}
	v[0].odd = true;
	v[1].link = 0;
	v[0].link = -1;
	v[0].cnt1 = v[0].cnt2 = 0;
	v[1].cnt1 = v[1].cnt2 = 0;
	cur = 1;
}

inline void add(int pos, int c) {
	for (;;) {
		if (v[cur].odd) {
			if (s[pos - 2 * v[cur].len] - 'a' == c) {
				break;
			}
		} else {
			if (s[pos - 2 * v[cur].len - 1] - 'a' == c) {
				break;
			}
		}
		cur = v[cur].link;
	}
	if (v[cur].next[c] != -1) {
		cur = v[cur].next[c];
		return;
	}
	for (int i = 0; i < 27; ++i) {
		v[sz].next[i] = -1;
	}
	v[sz].len = v[cur].len + 1;
	v[sz].odd = v[cur].odd;
	v[sz].cnt1 = v[sz].cnt2 = 0;
	v[cur].next[c] = sz;
	if (cur == 0) {
		cur = 1;
	} else {
		cur = v[cur].link;
		for (;;) {
			if (v[cur].odd) {
				if (s[pos - 2 * v[cur].len] - 'a' == c) {
					break;
				}
			} else {
				if (s[pos - 2 * v[cur].len - 1] - 'a' == c) {
					break;
				}
			}
			cur = v[cur].link;
		}
		cur = v[cur].next[c];
	}
	v[sz].link = cur;
	cur = sz++;
}

inline void solve() {
	gets(s);
	gets(t);
	init();
	int n = strlen(s), m = strlen(t);
	s[n++] = 'z' + 1;
	for (int i = 0; i < m; ++i) {
		s[n++] = t[i];
	}
	bool first = true;
	for (int i = 0; i < n; ++i) {
		add(i, s[i] - 'a');
		if (s[i] == 'z' + 1) {
			first = false;
			continue;
		}
		if (first) {
			++v[cur].cnt1;
		} else {
			++v[cur].cnt2;
		}
	}
	for (int i = sz - 1; i > 0; --i) {
		v[v[i].link].cnt1 += v[i].cnt1;
		v[v[i].link].cnt2 += v[i].cnt2;
	}
	ll ans = 0;
	for (int i = 2; i < sz; ++i) {
		ans += v[i].cnt1 * v[i].cnt2;
	}
	printf(LLD "\n", ans);
}

int main() {
#ifdef LOCAL42
#define TASK "G"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	gets(s);
	for (int i = 0; i < t; ++i) {
		printf("Case #%d: ", i + 1);
		solve();
	}
	return 0;
}
