#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 111;

struct state {

	int x, y;
	bool first;

	state() {}

	state(int x, int y, bool first) {
		this->x = x;
		this->y = y;
		this->first = first;
	}

};

vi g[N];
queue<state> q;
bool used[N][N][2], win[N][N][2], loose[N][N][2];
vector<state> go[N][N][2];
int deg[N][N][2];

inline void solve() {
	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a;
		--b;
		g[a].pb(b);
	}
	int x, y;
	scanf("%d %d", &x, &y);
	--x;
	--y;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int z = 0; z < 2; ++z) {
				win[i][j][z] = loose[i][j][z] = used[i][j][z] = false;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		loose[i][i][0] = true;
		used[i][i][0] = true;
		q.push(state(i, i, 0));
		win[i][i][1] = true;
		used[i][i][1] = true;
		q.push(state(i, i, 1));
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int z = 0; z < 2; ++z) {
				go[i][j][z].clear();
				deg[i][j][z] = 0;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int z = 0; z < 2; ++z) {
				if (z == 0) {
					for (int h = 0; h < sz(g[i]); ++h) {
						++deg[i][j][z];
						go[g[i][h]][j][1].pb(state(i, j, z));
					}
				} else {
					for (int h = 0; h < sz(g[j]); ++h) {
						++deg[i][j][z];
						go[i][g[j][h]][0].pb(state(i, j, z));
					}
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int z = 0; z < 2; ++z) {
				if (deg[i][j][z] == 0) {
					loose[i][j][z] = true;
					if (!used[i][j][z]) {
						used[i][j][z] = true;
						q.push(state(i, j, z));
					}
				}
			}
		}
	}
	while (!q.empty()) {
		state cur = q.front();
		q.pop();
		for (int i = 0; i < sz(go[cur.x][cur.y][cur.first]); ++i) {
			state ncur = go[cur.x][cur.y][cur.first][i];
			--deg[ncur.x][ncur.y][ncur.first];
			if (loose[cur.x][cur.y][cur.first]) {
				if (!used[ncur.x][ncur.y][ncur.first]) {
					win[ncur.x][ncur.y][ncur.first] = true;
					used[ncur.x][ncur.y][ncur.first] = true;
					q.push(ncur);
				} else {
					assert(win[ncur.x][ncur.y][ncur.first]);
				}
			} else if (win[cur.x][cur.y][cur.first]) {
				if (deg[ncur.x][ncur.y][ncur.first] == 0) {
					if (!used[ncur.x][ncur.y][ncur.first]) {
						loose[ncur.x][ncur.y][ncur.first] = true;
						used[ncur.x][ncur.y][ncur.first] = true;
						q.push(ncur);
					}
				}
			}
		}
	}
	if (win[x][y][0] || !loose[x][y][0]) {
		puts("Yes");
	} else {
		puts("No");
	}
}

int main() {
#ifdef LOCAL42
#define TASK "H"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		printf("Case #%d: ", i + 1);
		solve();
	}
	return 0;
}
