#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

struct node {
	node *go[2];
	bool term;
	node(): term(false) {
		go[0] = go[1] = NULL;
	}
};

typedef node *pnode;

int t;
int n;

pnode root;
vector<int> way;

void addWay(int x) {
	for (int i = 7; i >= 0; i--) {
		way.pb((x & (1 << i)) > 0);
	}
}

void addWay(const vector<int> &way) {
	pnode cur = root;
	for (int i = 0; i < len(way); i++) {
		if (!cur->go[way[i]]) {
			cur->go[way[i]] = new node();
		}
		cur = cur->go[way[i]];
	}
	cur->term = true;
}

vector<int> cur;
vector<vector<int> > answer;

void dfs(pnode root) {
	if (!root)
		return ;
	if (root->term)
		return ;
	if (!root->go[0]) {
		cur.pb(0);
		answer.pb(cur);
		cur.pop_back();
	} else {
		cur.pb(0);
		dfs(root->go[0]);
		cur.pop_back();
	}
	if (!root->go[1]) {
		cur.pb(1);
		answer.pb(cur);
		cur.pop_back();
	} else {
		cur.pb(1);
		dfs(root->go[1]);
		cur.pop_back();
	}
}

void printAnswer(const vector<int> &a, int l) {
	static int x[4];
	for (int i = 0; i < 4; i++) {
		x[i] = 0;
	}
	for (int i = 0; i < len(a); i++) {
		x[i / 8] = x[i / 8] * 2 + a[i];
	}
	printf("%d.%d.%d.%d/%d\n", x[0], x[1], x[2], x[3], l);
}

void solve() {
	scanf("%d", &n);
	if (n == 0) {
		puts("1");
		puts("0.0.0.0/0");
		return ;
	}
	root = new node();
	for (int i = 0; i < n; i++) {
		int a, b, c, d, l; scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &l);
		way.clear();
		addWay(a);
		addWay(b);
		addWay(c);
		addWay(d);
		way.resize(l);
		addWay(way);
	}
	answer.clear();
	cur.clear();
	dfs(root);
	printf("%d\n", len(answer));
	for (int i = 0; i < len(answer); i++) {
		int l = len(answer[i]);
		while (len(answer[i]) < 32) {
			answer[i].pb(0);
		}
		printAnswer(answer[i], l);
	}
}

int main() {
#ifdef LOCAL42
#define TASK "I"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		printf("Case #%d:\n", i + 1);
		solve();
	}
	return 0;
}
