#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const int MOD = 1000000007;
LL mpow(LL x, LL p) {
  LL r = 1;
  while (p) {
    if (p & 1) r = r * x % MOD;
    x = x * x % MOD;
    p /= 2;
  }
  return r;
}
LL minv(LL x) {
  return mpow(x, MOD - 2);
}

LL fact[1048576] = {1};
LL finv[1048576] = {1};

LL cnk(LL x, int k) {
  LL r = 1;
  FOR(i, 0, k) r = r * (x - i) % MOD;
  return r * finv[k] % MOD;
}

void test(int T) {
  int n, m, k;
  cin >> n >> m >> k;
  LL res = 0;
  LL sgn = 1;
  ROF(i, 1, k + 1) {
    res = (res + sgn * (i * mpow(i - 1, n - 1) % MOD) + MOD) % MOD;
    sgn = -sgn;
  }
  cout << "Case #" << T << ": " << res * cnk(m, k) % MOD << "\n";
}

int main() {
  FOR(i, 1, 1000001) fact[i] = fact[i - 1] * i % MOD, finv[i] = minv(fact[i]);
  int T;
  cin >> T;
  FOR(i, 0, T) test(i + 1);
  return 0;
}
