#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const int kN = 200 * 1000 + 5;

struct Node {
  int next[26];
  int suff;
  int len;
  int cnt;

  Node() : cnt(0) {
    memset(next, 255, sizeof(next));
  }
};

Node tree_s[kN];
int s_size = 0;
int t_size = 0;
Node tree_t[kN];
char s[kN];
char t[kN];
int suff;

void Add(Node* tree, char* s, int pos, int& size) {
  int curr = suff;
  while (true) {
    int len = tree[curr].len;
    if (s[pos] == s[pos - len - 1]) {
      break;
    }
    curr = tree[curr].suff;
  }
  int ch = s[pos] - 'a';
  if (tree[curr].next[ch] != -1) {
    int nxt = tree[curr].next[ch];
    ++tree[nxt].cnt;
    suff = nxt;
    return;  
  }
  tree[curr].next[ch] = size;
  tree[size].len = tree[curr].len + 2;
  tree[size].cnt = 1;
  suff = size;
  if (tree[size].len == 1) {
    tree[size].suff = 1;
    ++size;
    return;    
  }
  while (true) {
    curr = tree[curr].suff;
    int len = tree[curr].len;
    if (s[pos] == s[pos - len - 1]) {
      break;
    }
  }
  tree[size].suff = tree[curr].next[ch];
  ++size;
}

ll ans = 0;

void Init() {
  for (int i = 0; i != kN; ++i) {
    tree_s[i] = Node();
  }

  tree_s[0].len = -1; tree_s[0].suff = 0;
  tree_s[1].len = 0; tree_s[1].suff = 0;
  s_size = 2;

  for (int i = 0; i != kN; ++i) {
    tree_t[i] = Node();
  }

  tree_t[0].len = -1; tree_t[0].suff = 0;
  tree_t[1].len = 0; tree_t[1].suff = 0;
  t_size = 2;

  ans = 0;
}

ll pows[kN];
ll base = 31;
const ll kMod = 1000 * 1000 * 1000 + 7;

void PreCalc() {
  pows[0] = 1;
  for (int i = 1; i < kN; ++i) {
    pows[i] = pows[i - 1] * base % kMod;
  }
}


map<ll, ll> cnt_s;

void DFS0(int u, ll hash, int len) {
  cnt_s[hash] = tree_s[u].cnt;
  for (int i = 0; i < 26; ++i) {
    if (tree_s[u].next[i] == -1) {
      continue;
    }
    int v = tree_s[u].next[i];
    ll hash_new;
    if (tree_s[v].len == 1) {
      hash_new = i + 1;
    } else if (tree_s[v].len == 2) {
      hash_new = (i + 1) + base * (i + 1);
    } else {
     hash_new = (hash * base % kMod + (i + 1) + pows[len + 1] * (i + 1)) % kMod;
    }
    DFS0(v, hash_new, len + 2);
  } 
}

void DFS1(int u, ll hash, int len) {
  if (len >= 1) {
    auto it = cnt_s.find(hash);
    if (it == cnt_s.end()) { return; }
    ans += it->second * tree_t[u].cnt;

    cerr << hash << ' ' << it->second << ' ' << tree_t[u].cnt << '\n';
  }
    
 //cnt_s[hash] = tree_s[u].cnt;
  for (int i = 0; i < 26; ++i) {
    if (tree_t[u].next[i] == -1) {
      continue;
    }
    int v = tree_t[u].next[i];
    ll hash_new;
    if (tree_t[v].len == 1) {
      hash_new = i + 1;
    } else if (tree_t[v].len == 2) {
      hash_new = (i + 1) + base * (i + 1);
    } else {
     hash_new = (hash * base % kMod + (i + 1) + pows[len + 1] * (i + 1)) % kMod;
    }
    DFS1(v, hash_new, len + 2);
  } 

}

int main() {
  int T;
  PreCalc();
  scanf("%d", &T);
  FOR(t__, 0, T) {
    scanf("%s%s", s, t);
    fprintf(stderr, "%s\n%s\n", s, t);
    cnt_s.clear();
    Init();
    suff = 1;
    for (int i = 0; s[i]; ++i) {
      cerr << "!" << endl;
      Add(tree_s, &s[0], i, s_size);
    }
    for (int i = s_size - 1; i >= 0; --i) {
        tree_s[tree_s[i].suff].cnt += tree_s[i].cnt;
    }
    suff = 1;
    for (int i = 0; t[i]; ++i) {
      Add(tree_t, &t[0], i, t_size);
    }
    for (int i = 2; i < s_size; ++i) {
     cerr << "cnt = " << tree_s[i].cnt << " len = " << tree_s[i].len << endl; 
    }
    for (int i = t_size - 1; i >= 0; --i) {
      tree_t[tree_t[i].suff].cnt += tree_t[i].cnt;
    }
    cerr << "\n";
    for (int i = 2; i < t_size; ++i) {
     cerr << "cnt = " << tree_t[i].cnt << " len = " << tree_t[i].len << endl; 
    }
    DFS0(0, 0, -1);
    DFS0(1, 0, 0);
    DFS1(0, 0, -1);
    DFS1(1, 0, 0);
    printf("Case #%d: %lld\n", t__ + 1, ans);

  }
  return 0;
}
