#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

typedef pair <pair <int, int>, bool> State;
//map <State, int> verts;
vector<State> states;
vector <vector <int> > graph;
vector <int> inced;
vector <int> result;
int N, V;
int vert(int a, int b, bool c) {
/*  State curr = State(make_pair(a, b), c);
  auto f = verts.find(curr);
  if (f == verts.end()) {
    int ss = verts.size();
    verts[curr] = ss;
    graph.push_back(vector <int>());
    result.push_back(0);
    inced.push_back(0);
    states.push_back(curr);
    return ss;
  } else {
    return f->second;
  }*/
  return (a + b * N) * 2 + c;
}

void init(int n) {
  N = n;
  V = n * n * 2;
  states.resize(V);
  graph.clear();
  graph.resize(V);
  inced.resize(V);
  result.resize(V);
  FOR(i, 0, n) FOR(j, 0, n) FOR(c, 0, 2) {
    int s = vert(i, j, c);
    states[s] = State(make_pair(i, j), c);
    inced[s] = 0;
    result[s] = 0;
  }
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(__t, 0, T) {
    int n, m;
    scanf("%d%d", &n, &m);

    init(n);

    for (int i = 0; i != m; ++i) {
      int from, to;
      scanf("%d%d", &from, &to);
      --from, --to;

      for (int j = 0; j != n; ++j) {
        //if (j != from) {
        graph[vert(to, j, false)].push_back(vert(from, j, true));
        graph[vert(j, to, true)].push_back(vert(j, from, false));
        inced[vert(from, j, true)]++;
        inced[vert(j, from, false)]++;
      } 
    }

    vector <int> term;

    for (int i = 0; i != n; ++i) {
      term.push_back(vert(i, i, true)); result[vert(i, i, true)] = 2;
      term.push_back(vert(i, i, false)); result[vert(i, i, false)] = 2;
    }

    for (int i = 0; i != inced.size(); ++i) {
      if (!inced[i] && !result[i]) {
        term.push_back(i);
        result[i] = (states[i].second ? 2 : 1);
      }
    }

    while (!term.empty()) {
      int top = term.back();
      term.pop_back();

      for (int edge : graph[top]) {
        if ((states[edge].second ? 1 : 2) == result[top]) {
          if (!result[edge]) {
            result[edge] = result[top];
            term.push_back(edge);
          }
        } else {
          --inced[edge];
          if (!inced[edge] && !result[edge]) {
            result[edge] = (states[edge].second ? 2 : 1);
            term.push_back(edge);
          }
        }
      }
    }

    int a, b;
    scanf("%d%d", &a, &b);
    --a, --b;

    printf("Case #%d: %s\n", __t + 1, result[vert(a, b, true)] == 2 ? "No" : "Yes");

  }

  return 0;
}
