#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

typedef unsigned long long ip;

vector <string> answer;
void print(ip left, ip right, ip oleft = 0, ip oright = (1ULL << 32), int d = 0) {
  if (left <= oleft && right >= oright) {
    char str[256];
    sprintf(str, "%llu.%llu.%llu.%llu/%d", (oleft >> 24) & 0xFF, (oleft >> 16) & 0xFF, (oleft >> 8) & 0xFF, oleft & 0xFF, d);
    answer.push_back(str);
    return;
  }
  ip mid = (oright + oleft) / 2;
  if (left < mid) {
    print(left, right, oleft, mid, d + 1);
  }
  if (right > mid) {
    print(left, right, mid, oright, d + 1);
  }
}

int main() {
  //ios_base::sync_with_stdio(false);
  
  int T;
  scanf("%d", &T);

  FOR(__t, 0, T) {
    int n;
    scanf("%d", &n);
    //cin >> n;

    vector <pair <ip, int> > events(2 * n);
    for (int i = 0; i != n; ++i) {
      ip a, b, c, d, end;
      scanf("%llu.%llu.%llu.%llu/%llu", &a, &b, &c, &d, &end);

      ip curr = a * (1 << 24) + b * (1 << 16) + c * (1 << 8) + d;
      ip final;


      if (end == 0) {
        curr = 0;
        final = 0xFFFFFFFF;
      } else {
        end = 32 - end;
        curr = (curr & ~((1ULL << end) - 1)); 
        final = curr + ((1ULL << end) - 1);
      }
      events[2 * i] = pair <ip, int>(curr, + 1);
      events[2 * i + 1] = pair <ip, int>(final + 1, -1);
    }

    events.push_back(pair <ip, int>(1ULL << 32, 0));
    sort(events.begin(), events.end());

    answer.clear();
    ip count = 0, lastStart = 0;

    for (auto it = events.begin(); it != events.end(); ++it) {
      if (!count && lastStart < it->first) {
        print(lastStart, it->first);
      }
      
      count += it->second;
      lastStart = it->first;      
    }

    printf("Case #%d:\n%d\n", __t + 1, (int)answer.size());
    for (auto it = answer.begin(); it != answer.end(); ++it) {
      printf("%s\n", it->c_str());
    }
  }
  


  return 0;
}
