#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const long long ln = 4294967295LL;

struct node;
typedef node *Node;

struct node
{
    long long sum;
    int wish;
    bool need;
    Node left, right;
    node() : sum(0), wish(0), need(0), left(NULL), right(NULL){}
    void push(long long l, long long r)
    {
        if(!left) left = new node();
        if(!right) right = new node();
        if(!need)
            return;
        long long len = (l + r) / 2 - l + 1;
        left -> sum = len * wish;
        left -> wish = wish;
        left -> need = 1;

        right -> sum = len * wish;
        right -> wish = wish;
        right -> need = 1;

        need = 0;
        wish = 0;
    }
};

void set_s(Node root, long long vl, long long vr, long long L, long long R, int val)
{
    if(vl > R || vr < L)
        return;
    if(vl >= L && vr <= R)
    {
        root -> wish = val;
        root -> sum = (vr - vl + 1) * val;
        root -> need = 1;
        return;
    }
    root -> push(vl, vr);
    long long m = (vl + vr) / 2;
    set_s(root -> left, vl, m, L, R, val);
    set_s(root -> right, m + 1, vr, L, R, val);
    root -> sum = root -> left -> sum + root -> right -> sum;
}

void get_ans(Node root, long long vl, long long vr, vector <pair<long long, long long> > &vc)
{
    if(root -> sum == 0)
    {
        vc.pb(mp(vl, vr));
        return;
    }
    if(root -> sum == (vr - vl + 1))
        return;
    root -> push(vl, vr);
    long long m = (vl + vr) / 2;
    get_ans(root -> left, vl, m, vc);
    get_ans(root -> right, m + 1, vr, vc);
}

void m_clear(Node t)
{
    if(!t)
        return;
    m_clear(t -> left);
    m_clear(t -> right);
    delete t;
}

long long recount(int v1, int v2, int v3, int v4)
{
    return v4 + v3 * 256 + v2 * 256 * 256 + 1LL * v1 * 256 * 256 * 256;
}

void get_from(int &v1, int &v2, int &v3, int &v4, long long val)
{
    v4 = val % 256;
    val /= 256;
    v3 = val % 256;
    val /= 256;
    v2 = val % 256;
    val /= 256;
    v1 = val % 256;
    val /= 256;
}

int get_2pow(long long val)
{
    int ans = 0;
    long long cval = 1;
    while(cval < val)
    {
        ++ans;
        cval <<= 1;
    }
    return ans;
}

void print_ans(vector <pair<long long, long long> > &vc)
{
    cout << vc.size() << '\n';
    forn(i, vc.size())
    {
        int v1, v2, v3, v4, v5;
        get_from(v1, v2, v3, v4, vc[i].fs);
        v5 = get_2pow(vc[i].sc - vc[i].fs + 1);
        cout << v1 << "." << v2 << "." << v3 << "." << v4 << "/" << 32 - v5 << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    Node root;
    int t;
    cin >> t;
    forn(tt, t)
    {
        m_clear(root);
        root = new node();
        int n;
        cin >> n;
        forn(i, n)
        {
            char c;
            int v1, v2, v3, v4, v5;
            cin >> v1 >> c >> v2 >> c >> v3 >> c >> v4 >> c >> v5;
            long long l = recount(v1, v2, v3, v4);
            long long r = l + (1LL << (32 - v5)) - 1;
            set_s(root, 0, ln, l, r, 1);
        }
        cout << "Case #" << tt + 1 << ":\n";
        vector <pair<long long, long long> > vc;
        get_ans(root, 0, ln, vc);
        print_ans(vc);
    }
    return 0;
}
