#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;

const int MOD = 1000000007;

const int MAX_K = 100005;

ll invs[MAX_K];

ll binpow(ll n, ll k)
{
	if (k == 0)
	{
		return 1;
	}

	ll inn = binpow(n, k / 2);
	if (k % 2 == 0)
	{
		return (inn * inn) % MOD;
	}
	else
	{
		return ((inn * inn) % MOD * (n % MOD)) % MOD;
	}
}

ll inv(ll n)
{
	if (n < MAX_K)
	{
		return invs[n];
	}
	return binpow(n, MOD - 2);
}

ll comp(ll n, ll k)
{
	ll ans = 1;
	ll mul = n;
	ll div = 1;
	for (int i = 0; i < k; ++i)
	{
		ans = (((ans * mul) % MOD) * inv(div)) % MOD;
		mul -= 1;
		div += 1;
	}
	return ans % MOD;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	for (ll i = 1; i < MAX_K; ++i)
	{
		invs[i] = binpow(i, MOD - 2);
	}

    int tests;
	cin >> tests;

	for (int tc = 0; tc < tests; ++tc)
	{
		ll n, m, k;
		cin >> n >> m >> k;

		ll ans = (k * binpow(k - 1, n - 1)) % MOD;
		ans = (ans * comp(m, k)) % MOD;

		printf("Case #%d: %lld\n", tc + 1, ans);
	}

    return 0;
}