#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;

const ll MOD = 1000000007;

/*ll binpow(ll n, ll k)
{
	if (k == 0)
	{
		return 1;
	}

	ll inn = binpow(n, k / 2);
	if (k % 2 == 0)
	{
		return (inn * inn) % MOD;
	}
	else
	{
		return ((inn * inn) % MOD * n) % MOD;
	}
}*/
const int N = 1e6 + 100;

ll binpow(ll n, ll k)
{
	if (k == 0) return 1;
	if (k & 1)
		return (binpow(n, k - 1) * n) % MOD;
	ll b = binpow(n, k / 2);
	return (b * b) % MOD;
}

ll inv(ll n)
{
	return binpow(n, MOD - 2);
}

ll comp(ll n, ll k)
{
	ll ans = 1;
	ll mul = n;
	ll div = 1;
	for (int i = 0; i < k; ++i)
	{
		ans = (((ans * mul) % MOD) * inv(div)) % MOD;
		mul -= 1;
		div += 1;
	}
	return ans % MOD;
}

ll fact[N];
ll ifact[N];
ll t[N];

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	fact[0] = 1;
	ifact[0] = 1;
	for (ll i = 1; i < N; i++)
	{
		fact[i] = (fact[i - 1] * i) % MOD;
		ifact[i] = inv(fact[i]);
	}

    int tests;
	cin >> tests;

	for (int tc = 0; tc < tests; ++tc)
	{
		ll n, m, k;
		cin >> n >> m >> k;

		int sign = 1;
		ll ans = 0;
		ll mul = 1;
		ll div = 1;

		t[0] = 0;
		t[1] = 1;
		for (ll i = 2; i <= k; i++)
		{
			t[i] = binpow(i, n - 1);
		}

		for (int i = 0; i < k; ++i)
		{
			
			ll adding = 0;

			adding = (((((fact[k] * ifact[i]) % MOD) * ifact[k - i]) % MOD * (k - i)) % MOD * t[k - i - 1]) % MOD;

			if (i & 1)
				ans -= adding;
			else
				ans += adding;

			ans %= MOD;
			ans += MOD;
			ans %= MOD;

			/*ll add = ((k - i) * binpow(k - i - 1, n - 1)) % MOD;
			add = (((add * mul) % MOD) * inv(div)) % MOD;
			ans = (ans + sign * add + MOD) % MOD;
			mul = (mul * (k - i)) % MOD;
			div = (div * (i + 1)) % MOD;*/
			//sign *= -1;
		}

		ans = (ans * comp(m, k)) % MOD;

		printf("Case #%d: %lld\n", tc + 1, ans);
	}

    return 0;
}