#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

int n, m;
const int N = 110;
const int M = N * N;

const int NOT_DEFINED = 0;
const int BOB_WINNER = 1;
const int ALICE_WINNER = 2;
const int WAS_HERE = 3;

const int BOB_TURN = 0;
const int ALICE_TURN = 1;

vector<int> e[N];
int dp[N][N][2];

int f(int bob_vertex, int alice_vertex, int turn)
{
	if (turn == BOB_TURN && e[bob_vertex].size() == 0)
		return ALICE_WINNER;
	if (turn == ALICE_TURN && e[alice_vertex].size() == 0)
		return BOB_WINNER;
	if (bob_vertex == alice_vertex)
		return ALICE_WINNER;
	int &res = dp[bob_vertex][alice_vertex][turn];
	if (res != NOT_DEFINED)
	{
		if (res == WAS_HERE) return BOB_WINNER;
		return res;
	}
	res = WAS_HERE;
	if (turn == BOB_TURN)
	{
		int v = bob_vertex;
		bool can_win = 0;
		for (int i = 0; i < e[v].size(); i++)
		{
			int to = e[v][i];
			if (f(to, alice_vertex, ALICE_TURN) == BOB_WINNER)
			{
				can_win = true;
				break;
			}
		}
		if (can_win)
			res = BOB_WINNER;
		else
			res = ALICE_WINNER;
	}
	else
	{
		int v = alice_vertex;
		bool can_win = 0;
		for (int i = 0; i < e[v].size(); i++)
		{
			int to = e[v][i];
			if (f(bob_vertex, to, BOB_TURN) == ALICE_WINNER)
			{
				can_win = true;
				break;
			}
		}
		if (can_win)
			res = ALICE_WINNER;
		else
			res = BOB_WINNER;
	}
	return res;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	int test;
	cin >> test;
	for (int q = 0; q < test; q++)
	{
		cin >> n >> m;
		for (int i = 0; i < n; i++)
			e[i].clear();
		for (int i = 0; i < m; i++)
		{
			int a, b;
			cin >> a >> b;
			a--, b--;
			e[a].push_back(b);
		}
		int x, y;
		cin >> x >> y;
		x--, y--;
		cout << "Case #" << q + 1 << ": ";
		if (f(x, y, BOB_TURN) == BOB_WINNER)
			cout << "Yes\n";
		else
			cout << "No\n";
	}

    return 0;
}