#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

const int N = 30500;
int n;

ll log2(ll n)
{
	ll i = 0;
	while (true)
	{
		if ((1LL << (i+1)) > n)
		{
			return i;
		}
		++i;
	}
}

pl get_segment(string ip)
{
	ll a, b, c, d, m;
	sscanf(ip.c_str(), "%lld.%lld.%lld.%lld/%lld", &a, &b, &c, &d, &m);

	ll num;
	num = d | (c << 8) | (b << 16) | (a << 24);
	ll first = num;
	ll last = num;
	for (int i = 0; i < 32 - m; ++i)
	{
		last |= 1LL << i;
	}

	return mp(first, last);
}


char buf[200];
string get_good_ip(const pl& segment)
{
	ll mask = (1LL << 8) - 1;

	ll first = segment.first;
	ll d = first & mask;
	ll c = (first >> 8) & mask;
	ll b = (first >> 16) & mask;
	ll a = (first >> 24) & mask;

	ll delta = segment.second - segment.first + 1;
	assert(delta % 2 == 0 || delta == 1);

	ll m = 32 - log2(delta);

	sprintf(buf, "%lld.%lld.%lld.%lld/%lld", a, b, c, d, m);
	return string(buf);
}

vector<string> get_ip(const pl& segment)
{
	ll first = segment.first;
	ll second = segment.second;
	ll delta = segment.second - segment.first + 1;
	
	vector<string> ips;
	while (delta > 0)
	{
		ll zeroes = 0;
		for (; zeroes < 32; ++zeroes)
		{
			if ((first >> zeroes) & 1 == 1)
			{
				break;
			}
		}

		ll cur = min(delta, 1LL << zeroes);
		cur = 1LL << log2(cur);

		string new_ip = get_good_ip(mp(first, first + cur - 1));
		ips.push_back(new_ip);
		delta -= cur;
		first += cur;

	}


	return ips;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	string max_segm = "0.0.0.0/0";
	ll max_value = (1LL << 32) - 1;

	pl temp;
    int tests;
	cin >> tests;

	for (int tc = 0; tc < tests; ++tc)
	{
		vector < pl > sorted_segm;
		vector < pl > answer_segm;
		cin >> n;
		printf("Case #%d:\n", tc + 1);
		for (int i = 0; i < n; i++)
		{
			string s;
			cin >> s;
			temp = get_segment(s);
			sorted_segm.push_back(mp(temp.first, 1));
			sorted_segm.push_back(mp(temp.second, -1));
		}

		sort(sorted_segm.begin(), sorted_segm.end());
		if (sorted_segm.size() == 0)
		{
			printf("1\n%s\n", max_segm.c_str());
			continue;
		}

		int sz = sorted_segm.size();
		if (sorted_segm[0].first > 0)
		{
			answer_segm.push_back(mp(0, sorted_segm[0].first - 1));
		}
		if (sorted_segm[sz - 1].first < max_value)
		{
			answer_segm.push_back(mp(sorted_segm[sz - 1].first + 1, max_value));
		}

		int balance = sorted_segm[0].second;
		for (int i = 1; i < sz - 1; i++)
		{
			balance += sorted_segm[i].second;
			if (balance == 0)
			{
				answer_segm.push_back(mp(sorted_segm[i].first + 1, sorted_segm[i + 1].first - 1));
			}
		}

		vector <string> ans;
		for (int i = 0; i < answer_segm.size(); i++)
		{
			vector <string> got = get_ip(answer_segm[i]);
			ans.insert(ans.end(), got.begin(), got.end());
		}

		cout << ans.size() << endl;
		for (int i = 0; i < ans.size(); i++)
		{
			cout << ans[i] << endl;
		}
	}

    return 0;
}