#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 1e9 + 7;

ll ppow(ll a, ll b) {
	if (b == 0) return 1;
	if (b % 2 == 0) {
		ll t = ppow(a, b / 2);
		return (t * t) % mod;
	} else {
		return (ppow(a, b - 1) * a) % mod;
	}
}

ll cnk(ll n, ll k) {
	ll ans = 1, zn = 1;
	for (ll i = n; i >= n - k + 1; i--)
		ans = (ans * i) % mod;
	for (ll i = 1; i <= k; i++)
		zn = (zn * i) % mod;
	return (ans * ppow(zn, mod - 2)) % mod;
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		ll n, m, k;
		scanf("%lld%lld%lld", &n, &m, &k);
		vector <ll> dp (k + 1, 0);
		dp[0] = 0;
		ll s = 0;
		for (int i = 1; i <= k; i++) {
			dp[i] = (ppow(i - 1, n - 1) * i) % mod;
			dp[i] = (dp[i] - s + mod) % mod;
			s = (s + dp[i]) % mod;
		}
		ll ans = (dp[k] * cnk(m, k)) % mod;
		printf("Case #%d: %lld\n", i + 1, ans);
	}

	return 0;
}