#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 1e9 + 7;

ll ppow(ll a, ll b) {
	if (b == 0) return 1;
	if (b % 2 == 0) {
		ll t = ppow(a, b / 2);
		return (t * t) % mod;
	} else {
		return (ppow(a, b - 1) * a) % mod;
	}
}

ll cnk(ll n, ll k) {
	ll ans = 1, zn = 1;
	for (ll i = n; i >= n - k + 1; i--)
		ans = (ans * i) % mod;
	for (ll i = 1; i <= k; i++)
		zn = (zn * i) % mod;
	return (ans * ppow(zn, mod - 2)) % mod;
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	scanf("%d", &t);
	for (int j = 0; j < t; j++) {
		ll n, m, k;
		scanf("%lld%lld%lld", &n, &m, &k);
		vector <ll> g (k + 1, 0);
		for (int i = 1; i <= k; i++)
			g[i] = (ppow(i - 1, n - 1) * i) % mod;
		vector <ll> c (k + 1, 0);
		c[0] = 1;
		for (int i = 1; i <= k; i++)
			c[i] = (((c[i - 1]*(k - i + 1)) % mod) * ppow(i, mod - 2)) % mod;
		ll ans = 0;
		for (int i = k; i >= 1; i--) {
			if ((k - i) % 2 == 0)
				ans = (ans + ((c[i]*g[i]) % mod)) % mod;
			else				
				ans = (ans - ((c[i]*g[i]) % mod) + mod) % mod;
		}
		ans = (ans * cnk(m, k)) % mod;
		printf("Case #%d: %lld\n", j + 1, ans);
	}

	return 0;
}