#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 20000*100 + 10;
const dbl eps = 1e-9;
const int mod = 1e9 + 7;

struct node {
	int level;
	bool have_marked;
	bool is_end;
	node * son0, *son1;
	node () {};
	node (int level) : level(0), have_marked(false), is_end(false), son0(0), son1(0) {};
};

typedef node * pnode;

vector<string> ans;

void dfs(pnode cur, string s) {
	if (cur->level == 32 || cur->is_end) {
		return;
	}
	if (!cur->have_marked) {
		ans.pb(s);
		return;
	}

	if (cur->son0 != 0) {
		dfs(cur->son0, s + '0');
	} else {
		ans.pb(s + '0');
	}

	if (cur->son1 != 0) {
		dfs(cur->son1, s + '1');
	} else {
		ans.pb(s + '1');
	}
}

int f(string s) {
	if (sz(s) == 0) return 0;
	int ans = 0;
	while (sz(s) != 8) s += '0';
	reverse(all(s));
	for (int i = 0; i < sz(s); i++) {
		if (s[i] == '1')
			ans += (1 << i);
	}
	return ans;
}


ll ppow(ll a, ll b) {
	if (b == 0) return 1;
	if (b % 2 == 0) {
		ll t = ppow(a, b / 2);
		return (t * t) % mod;
	} else {
		return (ppow(a, b - 1) * a) % mod;
	}
}

ll fact[maxn];
ll c[maxn];

ll cnk(ll n, ll k) {
	ll ans = 1, zn = fact[k];
	for (ll i = n; i >= n - k + 1; i--)
		ans = (ans * i) % mod;
	return (ans * ppow(zn, mod - 2)) % mod;
}


int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	fact[0] = 1;
	for (ll i = 1; i <= 1000000; i++)
		fact[i] = (fact[i - 1] * i) % mod;
	int t;
	scanf("%d", &t);
	for (int j = 0; j < t; j++) {
		ll n, m, k;
		scanf("%lld%lld%lld", &n, &m, &k);
		if (k == 1) {
			if (n == 1)
				printf("Case #%d: %lld\n", j + 1, m);
			else
				printf("Case #%d: %lld\n", j + 1, 0);
			continue;
		}
		c[0] = 1;
		for (int i = 1; i <= k/2; i++)
			c[i] = (((c[0]*(k - i + 1)) % mod) * ppow(i, mod - 2)) % mod;

		int ans = 0;
		for (ll i = 0; i < k; i++) {
			int add = ((k - i)*(ppow((k - i - 1), n - 1)*c[min(i, k - i)]) % mod) % mod;
			if (i % 2 != 0)
				add = (mod - add) % mod;
			ans = (ans + add) % mod;
		}
		//ans = (ans * ppow(fact[k], mod - 2)) % mod;
		ans = (ans * cnk(m, k)) % mod;
		printf("Case #%d: %lld\n", j + 1, ans);
		cerr << (double)clock() / CLOCKS_PER_SEC << endl;
	}

	return 0;
}