#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 100 + 10;
const dbl eps = 1e-9;
const ll mod = 1e9 + 7;

vector<int> g[maxn];
vector< pair< pair<int, int>, int > > r[111][111][2];
bool used[111][111][2];


int dfs(int x, int y, int who) {
	used[x][y][who] = true;
	if (x == y) return 1;
	int count0 = 0, count1 = 0;
	bool flag = false;
	for (int i = 0; i < sz(r[x][y][who]); i++) {
		pair< pair<int, int>, int> next = r[x][y][who][i];
		flag = true;
		if (used[next.X.X][next.X.Y][next.Y]) {
			if (next.X.X == next.X.Y) count1++;
			else count0++;
			continue;
		}
		int cur = dfs(next.X.X, next.X.Y, next.Y);
		if (cur == 0) count0++;
		else count1++;
	}

	if (!flag) {
		return 1 - who;
	}

	if (!who) {
		if (count0 > 0) {
			//win[x][y][who] = 0;
			return 0;
		}
	//	win[x][y][who] = 1;
		return 1;
	} else {
		if (count1 > 0) {
		//	win[x][y][who] = 1;
			return 1;
		}
	//	win[x][y][who] = 0;
		return 0;
	}
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	scanf("%d", &t);
	for (int n_test = 0; n_test < t; n_test++) {
		int n, m;
		scanf("%d%d", &n, &m);

		for (int i = 1; i <= n; i++)
			g[i].clear();

		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
				for (int q = 0; q < 2; q++) {
					r[i][j][q].clear();
					used[i][j][q] = false;
				//	win[i][j][q] = -1;
				}

		for (int i = 0; i < m; i++) {
			int x, y;
			scanf("%d%d", &x, &y);
			g[x].pb(y);
		}

		int sx, sy;
		scanf("%d%d", &sx, &sy);

		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				for (int y = 0; y < sz(g[i]); y++)
					r[i][j][0].pb(mp(mp(g[i][y], j), 1));
				for (int y = 0; y < sz(g[j]); y++)
					r[i][j][1].pb(mp(mp(i, g[j][y]), 0));
			}
		}

		int ans = dfs(sx, sy, 0);
		printf("Case #%d: ", n_test + 1);
		puts(ans ? "No" : "Yes");
	}

	return 0;
}