#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 1e9 + 7;

struct node {
	int level;
	bool have_marked;
	bool is_end;
	node * son0, *son1;
	node () {};
	node (int level) : level(0), have_marked(false), is_end(false), son0(0), son1(0) {};
};

typedef node * pnode;

vector<string> ans;

void dfs(pnode cur, string s) {
	if (cur->level == 32 || cur->is_end) {
		return;
	}
	if (!cur->have_marked) {
		ans.pb(s);
		return;
	}

	if (cur->son0 != 0) {
		dfs(cur->son0, s + '0');
	} else {
		ans.pb(s + '0');
	}

	if (cur->son1 != 0) {
		dfs(cur->son1, s + '1');
	} else {
		ans.pb(s + '1');
	}
}

int f(string s) {
	if (sz(s) == 0) return 0;
	int ans = 0;
	while (sz(s) != 8) s += '0';
	reverse(all(s));
	for (int i = 0; i < sz(s); i++) {
		if (s[i] == '1')
			ans += (1 << i);
	}
	return ans;
}


ll ppow(ll a, ll b) {
	if (b == 0) return 1;
	if (b % 2 == 0) {
		ll t = ppow(a, b / 2);
		return (t * t) % mod;
	} else {
		return (ppow(a, b - 1) * a) % mod;
	}
}

ll cnk(ll n, ll k) {
	ll ans = 1, zn = 1;
	for (ll i = n; i >= n - k + 1; i--)
		ans = (ans * i) % mod;
	for (ll i = 1; i <= k; i++)
		zn = (zn * i) % mod;
	return (ans * ppow(zn, mod - 2)) % mod;
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	for (int n_test = 0; n_test < t; n_test++) {
		int n;
		scanf("%d", &n);
		if (n == 0) {
			printf("Case #%d: \n1\n0.0.0.0/0\n", n_test + 1);
			continue;
		}
		ans.clear();
		pnode tree = new node(0);
		for (int i = 0; i < n; i++) {
			int a, b, c, d, l;
			scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &l);
			int m = d + c * 256 + b * 256 * 256 + a * 256 * 256 * 256;

			pnode cur = tree;
			for (int j = 31, level = 0; j >= 32 - l; j--, level++) {
				int curbit = (m >> j) & 1;
				
				if (curbit == 0) {
					if (cur->son0 == 0)
						cur->son0 = new node(level + 1);
					cur->have_marked = true;
					cur = cur->son0;
				} else {
					if (cur->son1 == 0)
						cur->son1 = new node(level + 1);
					cur->have_marked = true;
					cur = cur->son1;
				}
				if (j == 32 - l) cur->is_end = true;
			}
		}

		dfs(tree, "");
		printf("Case #%d:\n%d\n", n_test + 1, sz(ans));
		for (int i = 0; i < sz(ans); i++) {
				int tt = sz(ans[i]);
				while (sz(ans[i]) != 32) ans[i] += '0';
				string t = ans[i].substr(0, 8);
				printf("%d.", f(t));
			
				t = ans[i].substr(8, 8);
				printf("%d.", f(t));

				 t = ans[i].substr(16, 8);
				printf("%d.", f(t));
			
				t = ans[i].substr(24, 8);
				printf("%d", f(t));
			printf("/%d\n", tt);
		}
	}
	/*int t;
	scanf("%d", &t);
	for (int j = 0; j < t; j++) {
		ll n, m, k;
		scanf("%lld%lld%lld", &n, &m, &k);
		if (k == 1) {
			if (n == 1)
				printf("Case #%d: %lld\n", j + 1, m);
			else
				printf("Case #%d: %lld\n", j + 1, 0);
			continue;
		}
		ll ans = cnk(m, k - 1);
		ll g = (((m - k + 1) * ppow(k - 1, n - 1)) % mod);
		ll g2 = ((k - 1) * ppow(k - 2, n - 1)) % mod;
		ans = (ans * ((g - g2 + mod) % mod)) % mod;
		printf("Case #%d: %lld\n", j + 1, ans);
	}*/
	return 0;
}