#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 1e9 + 7;

ll ppow(ll a, ll b) {
	if (b == 0) return 1;
	if (b % 2 == 0) {
		ll t = ppow(a, b / 2);
		return (t * t) % mod;
	} else {
		return (ppow(a, b - 1) * a) % mod;
	}
}

ll cnk(ll n, ll k) {
	ll ans = 1, zn = 1;
	for (ll i = n; i >= n - k + 1; i--)
		ans = (ans * i) % mod;
	for (ll i = 1; i <= k; i++)
		zn = (zn * i) % mod;
	return (ans * ppow(zn, mod - 2)) % mod;
}

ll gcd (ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		ll a, b;
		scanf("%lld%lld", &a, &b);
		if (a < b)
			swap(a, b);
		if (b == 0) {
			if (a == 0) 
				printf("Case #%d: %lld\n", i + 1, 1LL);
			else
				printf("Case #%d: %lld\n", i + 1, 2LL);
			continue;
		}
		ll d = gcd(a, b);
		a /= d;
		b /= d;
		ll ans = 2;
		while (b != 1) {
			ll k = a/b;
			ans += k;
			a -= k*b;
			swap(a, b);
		}
		printf("Case #%d: %lld\n", i + 1, ans + a - 1);
	}

	return 0;
}