#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int n, m, k;

ll mod = 1000000007;

//ll mem[1000][1000];

// O(n * k)
/*
ll dp1(int n, int used) {

    if (used > k) {
        return 0;
    }

    if (n == 0) {
        return used == k ? 1 : 0;
    }

    if (mem[n][used] != -1) {
        return mem[n][used];
    }

    return (((used - 1) * dp1(n-1, used)) % mod + ((m - used) * dp1(n-1, used+1)) % mod) % mod;
}

int dp2(int n, int used) {

    if (used > k) {
        return 0;
    }

    if (n == 0) {
        return used == k ? 1 : 0;
    }

    int res = pow(used - 1, n) * dp2(0, used);
    for (int nxt = 0; n - 1 - nxt >= 0; nxt++) {
        res += pow(used - 1, nxt) * (m - used) * dp2(n - 1 - nxt, used + 1);
    }

    return res;

    //return (used - 1) * dp(n-1, used) + (k - used) * dp(n-1, used+1);
}
*/

//ll mod_inv(ll a, ll m);
int mod_inv(int a, int m);

long long binomial(int n, int k) {
    ll res = 1;
    for (int i = 1; i <= k; i++) {
        res *= n - k + i;
        res %= mod;
        res *= mod_inv(i, mod);
        res %= mod;
    }

    return res;
}

ll mypow(ll a, ll b, ll m) {
    ll res = 1;
    while (b) {
        if (b & 1) {
            res = (res * a) % m;
        }

        a = (a * a) % m;
        b >>= 1;
    }

    return res;
}

int egcd(int a, int b, int &x, int &y) {
    if (b == 0) { x = 1; y = 0; return a; }
    else {
        int d = egcd(b, a % b, x, y);
        x -= a / b * y;
        swap(x, y);
        return d;
    }
}

int mod_inv(int a, int m) {
    int x, y, d = egcd(a, m, x, y);
    //assert(d == 1);
    return x < 0 ? x + m : x;
    //return mypow(a, m - 2, m);
}

int main() {
    int ts;
    scanf("%d\n", &ts);
    for (int t = 0; t < ts; t++) {
        //memset(mem, -1, sizeof(mem));

        scanf("%d %d %d\n", &n, &m, &k);
        //cin >> n >> m >> k;
        printf("Case #%d: ", t+1);
        //cout << "Case #" << (t+1) << ": ";


        ll bin = 1;
        ll res = 0;
        for (int i = 0; i <= k; i++) {
            //ll cur = ((((k-i) * mypow(k-i-1, n-1, mod)) % mod) * binomial(k, i)) % mod;
            ll cur = ((((k-i) * mypow(k-i-1, n-1, mod)) % mod) * bin) % mod;
            if (i % 2 != 0) {
                cur = mod - cur;
            }

            res += cur;
            if (res >= mod) {
                res -= mod;
            }

            bin *= k - i;
            bin %= mod;
            bin *= mod_inv(i + 1, mod);
            bin %= mod;
        }

        res *= binomial(m, k);
        res %= mod;

        printf("%d\n", static_cast<int>(res));

        /*
        ll res = k * mypow(k-1, n-1, mod);
        res %= mod;
        res += mod - ((k-1) * mypow(k - 2, n-1, mod)) % mod;
        res %= mod;
        res *= binomial(m, k);
        res %= mod;
        */

        //cout << res << endl;
        //cout << (m*dp1(n-1, 1)) % mod << endl;
        /*
        cout << m*dp1(n-1, 1);
        cout << " ";
        cout << m*dp2(n-1, 1);
        cout << endl;
        */
    }

    return 0;
}
