#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

void print_ip(ll x) {
    int d = x & ((1 << 8) - 1);
    x >>= 8;
    int c = x & ((1 << 8) - 1);
    x >>= 8;
    int b = x & ((1 << 8) - 1);
    x >>= 8;
    int a = x & ((1 << 8) - 1);

    printf("%d.%d.%d.%d", a, b, c, d);
}

vector<pair<ll, int> > res;

ll cover(ll a, ll b) {
    if (a > b) {
        return 0;
    }

    /*
    printf("covering:\n");
    print_ip(a);
    printf("\n");
    print_ip(b);
    printf("\n");
    */

    ll both = ~(a ^ b);
    int prefix = 0;
    while (both & (1LL << (31 - prefix))) {
        prefix++;
        if (prefix == 32) {
            break;
        }
    }

    int suffix = 32 - prefix;
    //printf("%d %d\n", prefix, suffix);

    ll asuff = a & ((1LL << suffix) - 1);
    ll bsuff = b & ((1LL << suffix) - 1);

    if (asuff == 0 && bsuff == ((1LL << suffix) - 1)) {
        res.push_back(make_pair(a, prefix));
    } else {
        cover(a, a | ((1LL << suffix) - 1));
        cover((a | ((1LL << suffix) - 1)) + 1, b);
    }

    return 0;
}

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        cout << "Case #" << (t+1) << ":" << endl;

        res.clear();

        int n;
        scanf("%d\n", &n);
        vector<pair<ll, ll> > subnets;

        for (int i = 0; i < n; i++) {
            int a, b, c, d, e;

            scanf("%d.%d.%d.%d/%d\n", &a, &b, &c, &d, &e);

            e = 32 - e;

            ll ip = ((ll)a << 24) | ((ll)b << 16) | ((ll)c << 8) | ((ll)d);
            ll mn = ip & ~((1LL << e) - 1);
            ll mx = ip | ((1LL << e) - 1);
            subnets.push_back(make_pair(mn, mx));
        }

        ll last = 0;
        sort(subnets.begin(), subnets.end());

        for (int i = 0; i < size(subnets); ) {
            ll start = subnets[i].first,
               end = subnets[i].second;

            cover(last, start - 1);
            while (i + 1 < size(subnets) && subnets[i + 1].first <= end) {
                end = max(end, subnets[i+1].second);
                i++;
            }

            i++;
            last = end + 1;
        }

        cover(last, (1LL << 32) - 1);

        printf("%d\n", size(res));
        for (int i = 0; i < size(res); i++) {
            print_ip(res[i].first);
            printf("/%d\n", res[i].second);
        }

    }

    return 0;
}
