#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

long long gcd(long long a, long long b) {
    return b == 0 ? a : gcd(b, a % b);
}

int brute(long long a, long long b) {
    set<pair<ll, ll> > seen;
    set<ll> seen2;
    while (true) {
        if (seen2.find(a) == seen2.end()) {
            seen2.insert(a);
        }

        if (seen.find(make_pair(a, b)) != seen.end()) {
            break;
        }

        seen.insert(make_pair(a, b));
        a = abs(a - b);
        swap(a, b);
    }

    if (seen2.find(b) == seen2.end()) {
        seen2.insert(b);
    }

    return size(seen2);
}

int brute2(ll a, ll b) {
    int cnt = 2;
    while (true) {
        if (a > b) {
            swap(a, b);
        }

        //cout << a << " " << b << endl;
        if (a == 0) {
            break;
        }


        b -= a;
        cnt++;
    }
    return cnt - 1;
}

int main() {
    int ts;
    cin >> ts;
    for (int t = 0; t < ts; t++) {
        long long a, b;
        cin >> a >> b;
        cout << "Case #" << (t+1) << ": ";
        if (a == 0 && b == 0) {
            cout << 1 << endl;
        } else if (a == 0 || b == 0) {
            cout << 2 << endl;
        }
        else {
            cout << brute2(a, b) << endl;
            //cout << max(a, b) / min(a, b) << endl;
        }
        /*
        } else if (a < b) {
            //cout << max(a, b - a) / gcd(a, b) + 2 << endl;
            // cout << (b - a) / gcd(a, b) + 2 << endl;
            cout << a / min(b - a, abs(2*a - b)) + 2 << endl;
        } else if (b < a) {
            // cout << (a - b) / gcd(a, b) + 2 << endl;
            cout << b / min(a - b, abs(2*b - a)) + 2 << endl;
        } else {
            cout << 2 << endl;
        }
        */
//        cout << brute(a, b) << endl;
    }

    return 0;
}
