#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

const int N = 105;

int n, m, x, y;
vector <int> g[N], gt[N];
int w[2][N][N];
int d[2][N][N];

enum {
	NONE,
	ALICE,
	BOB
};

bool read() {
	if (scanf("%d %d", &n, &m) != 2)
		return false;

	memset(d, 0, sizeof(d));
	memset(w, 0, sizeof(w));

	forn(i, N) {
		g[i].clear();
		gt[i].clear();
	}

	forn(i, m) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a, --b;
		g[a].pb(b);
		gt[b].pb(a);
	}

	scanf("%d %d", &x, &y);
	--x, --y;
	return true;
}

void solve() {
	forn(i, n) {
		forn(j, n) {
			forn(t, 2) {
				w[t][i][j] = NONE;

				if (i == j) {
					w[t][i][j] = ALICE;
				} else {
					int cur = t ? j : i;
					if (g[cur].empty())
						w[t][i][j] = t ? BOB : ALICE;
				}

				int my = t ? i : j;
				forn(k, sz(gt[my])) {
					int to = gt[my][k];
					d[!t][t ? to : i][t ? j : to]++;
				}
			}
		}
	}

	queue < pair<int,pt> > q;

	forn(i, n)
		forn(j, n)
			forn(t, 2) {
				if (w[t][i][j] != NONE) {
					d[t][i][j] = -1;
					q.push(mp(t, mp(i, j)));
				}
			}

	while (!q.empty()) {
		int t = q.front().ft;
		int i = q.front().sc.ft;
		int j = q.front().sc.sc;
		q.pop();

		assert(w[t][i][j] != NONE);

		int my = t ? i : j;
		forn(k, sz(gt[my])) {
			int to = gt[my][k];

			pt tt = mp(t ? to : i, t ? j : to);

			int &dt = d[!t][tt.ft][tt.sc];
			int &wt = w[!t][tt.ft][tt.sc];
			
			if (wt != NONE)
				continue;

			if (t == (w[t][i][j] == ALICE)) {
				--dt;
				if (dt == 0) {
					wt = t ? ALICE : BOB;
					q.push(mp(!t, tt));
				}
			} else {
				dt = -1;
				wt = w[t][i][j];
				q.push(mp(!t, tt));
			}
		}		
	}

	puts(w[0][x][y] == ALICE ? "No" : "Yes");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	forn(i, t) {
		printf("Case #%d: ", i + 1);
		assert(read());
		solve();
	}

	return 0;
}