#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<li,li> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n;
vector<pt> v;
li mask[33];

bool read() {
	if (scanf("%d", &n) != 1)
		return false;
	v.clear();
	forn (i, n)
	{
		int a, b, c, d, e;
		scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &e);
		li l = (a << 24) + (b << 16) + (c << 8) + d;
		l &= mask[e];
		li r = l + (1LL << (32 - e)) - 1;
		v.pb(mp(l, r));
	}
	return true;
}

vector<pt> merge(vector<pt> &a)
{
	vector<pt> res;
	sort(a.begin(), a.end());
	a.pb(mp(1LL << 32, 1LL << 32));

	li l = a[0].ft;
	li r = a[0].sc;
	forn (i, a.size())
	{
		if (a[i].ft <= r + 1)
			r = max(a[i].sc, r);
		else
		{
			res.pb(mp(l, r));
			l = a[i].ft, r = a[i].sc;
		}
	}

	res.pb(mp(l, r));

	return res;
}

int tc = 0;

void rest(pt p)
{
	int e = 0;
	if (p.sc)
	{
		p.sc--;
		while(p.sc & (1LL << e))
			e++;
		e = 32 - e;
	}
	int a = p.ft >> 24, b = p.ft >> 16, c = p.ft >> 8, d = p.ft & 255;
	b &= 255, c &= 255;
	printf("%d.%d.%d.%d/%d\n", a, b, c, d, e);
}

void solve() {
	tc++;
	cout << "Case #" << tc << ":" << endl;
	v = merge(v);
	li l = 0;
	int cur = 0;
	if (v[0].ft == 0)
		l = v[0].sc + 1, cur++;
	vector<pt> ans;
	while(cur < v.size() && l + 1 < v.back().ft)
	{
		li r = 1;
		li maxr = l == 0 ? (1LL << 32) : (1 + ((l & (l - 1)) ^ (l - 1)));
		while (l + r * 2 <= v[cur].ft)
			r *= 2;
		r = min(r, maxr);
		ans.pb(mp(l, r));
		l += r;
		if (l == v[cur].ft)
			l = v[cur].sc + 1, cur++;
	}
	forn (i, ans.size())
		v.pb(mp(ans[i].ft, ans[i].ft + ans[i].sc - 1));
	v = merge(v);
	assert(v.size() == 1);
	cout << ans.size() << endl;
	forn (i, ans.size())
		rest(ans[i]);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	cin >> t;
	mask[1] = 1LL << 31;
	for (int i = 2; i < 33; ++i)
		mask[i] = mask[i - 1] | (1LL << (31 - i));

	while (read())
		solve();

	return 0;
}