#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define H 31
#define MOD 1234567891

using namespace std;
int T, na, nb, nr[2][400100], hashpart[400100], Put[400100], inv[400100];
char A[400100], B[400100];
long long sol;

struct Trie
{
    Trie *fiu[26], *fiustar;
    int fr[2];
    Trie()
    {
        fr[0] = fr[1] = 0;
        memset(fiu, 0, sizeof(fiu));
        fiustar = 0;
    }
};
Trie *RA, *RB;
unordered_map <int, Trie * > Map;

inline int LgPut(int baz, int put)
{
    int rez = 1LL;
    while(put)
    {
        if(put % 2LL == 1LL)
        {
            rez = (1LL * rez * baz) % MOD;
            put--;
        }
        baz = (1LL * baz * baz) % MOD;
        put /= 2LL;
    }
    return rez;
}

inline void Manacher(int best[], char s[], int ns)
{
    int i, j, st, dr;
    best[1] = 1;
    best[2] = 2;
    st = 1;
    dr = 3;
    for(i = 3; i <= ns; ++i)
    {
        if(i > dr)
        {
            st = dr = i;
            best[i] = 0;
            while(st > 0 && dr <= ns && s[st] == s[dr])
            {
                best[i]++;
                st--;
                dr++;
            }
            st++;
            dr--;
            continue;
        }
        j = st + (dr - i);
        if(i + best[j] - 1 < dr)
        {
            best[i] = best[j];
            continue;
        }
        best[i] = dr + 1 - i;
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        best[i]--;
        while(st > 0 && dr <= ns && s[st] == s[dr])
        {
            best[i]++;
            st--;
            dr++;
        }
        st++;
        dr--;
    }
}

Trie * Build(int best[], char s[], int ns, Trie *R, int ind)
{
    int i, st, dr, hashnow, mij;
    bool ok;
    Trie *fiu, *tata, *bunic;
    for(i = 1; i <= ns; ++i)
        hashpart[i] = (1LL * hashpart[i - 1] + 1LL * Put[i] * s[i]) % MOD;
    for(i = 1; i <= ns; ++i)
    {
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        mij = (st + dr) / 2;
        hashnow = hashpart[mij] - hashpart[st - 1];
        if(hashnow < 0)
            hashnow += MOD;
        hashnow = (1LL * hashnow * inv[st]) % MOD;
        if(!Map[hashnow])
            Map[hashnow] = new Trie();
        fiu = Map[hashnow];
        fiu -> fr[ind]++;
        if(st == dr)
        {
            if(s[st] == '*')
                R -> fiustar = fiu;
            else
                R -> fiu[s[st] - 'a'] = fiu;
            continue;
        }
        dr--;
        st++;
        hashnow = hashpart[mij] - hashpart[st - 1];
        if(hashnow < 0)
            hashnow += MOD;
        hashnow = (1LL * hashnow * inv[st]) % MOD;
        ok = true;
        if(!Map[hashnow])
            Map[hashnow] = new Trie();
        else
            ok = false;
        tata = Map[hashnow];
        if(s[st - 1] == '*')
            tata -> fiustar = fiu;
        else
            tata -> fiu[s[st - 1] - 'a'] = fiu;
        while(ok)
        {
            fiu = tata;
            if(st == dr)
            {
                if(s[st] == '*')
                    R -> fiustar = fiu;
                else
                    R -> fiu[s[st] - 'a'] = fiu;
                ok = false;
                continue;
            }
            dr--;
            st++;
            hashnow = hashpart[mij] - hashpart[st - 1];
            if(hashnow < 0)
                hashnow += MOD;
            hashnow = (1LL * hashnow * inv[st]) % MOD;
            if(!Map[hashnow])
                Map[hashnow] = new Trie();
            else
                ok = false;
            tata = Map[hashnow];
            if(s[st - 1] == '*')
                tata -> fiustar = fiu;
            else
                tata -> fiu[s[st - 1] - 'a'] = fiu;
        }
    }
    return R;
}

Trie * Propaga(Trie *nod, int ind)
{
    if(nod == 0)
        return 0;
    int i;
    for(i = 0; i < 26; ++i)
    {
        if(nod -> fiu[i] != 0)
        {
            nod -> fiu[i] = Propaga(nod -> fiu[i], ind);
            nod -> fr[ind] += nod -> fiu[i] -> fr[ind];
        }
    }
    if(nod -> fiustar != 0)
    {
        nod -> fiustar = Propaga(nod -> fiustar, ind);
        nod -> fr[ind] += nod -> fiustar -> fr[ind];
    }
    return nod;
}

Trie * Remove(Trie *nod)
{
    if(nod == 0)
        return 0;
    int i;
    for(i = 0; i < 26; ++i)
    {
        if(nod -> fiu[i] != 0)
        {
            nod -> fiu[i] = Remove(nod -> fiu[i]);
            delete nod -> fiu[i];
        }
    }
    if(nod -> fiustar != 0)
    {
        nod -> fiustar = Remove(nod -> fiustar);
        delete nod -> fiustar;
    }
    return nod;
}

void Solve(Trie *R, bool permis)
{
    if(R == 0 || R -> fr[0] == 0 || R -> fr[1] == 0)
        return;
    int i;
    if(permis)
        sol += 1LL * (R -> fr[0]) * (R -> fr[1]);
    for(i = 0; i < 26; ++i)
        Solve(R -> fiu[i], true);
    Solve(R -> fiustar, false);
}

int main ()
{
#ifdef local
    freopen ("g.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, t, st, dr;
    cin >> T;
    Put[0] = 1;
        inv[0] = 1;
    for(i = 1; i <= 400010; ++i)
    {
        Put[i] = (1LL * H * Put[i - 1]) % MOD;
        inv[i] = LgPut(Put[i], MOD - 2);
    }
    for(t = 1; t <= T; ++t)
    {
        cin >> (A + 1);
        cin >> (B + 1);
        na = strlen(A + 1);
        nb = strlen(B + 1);
        sol = 0LL;
        Map.clear();
        A[2 * na + 1] = '*';
        for(i = 2 * na; i > 0; i -= 2)
        {
            A[i] = A[i / 2];
            A[i - 1] = '*';
        }
        na = 2 * na + 1;
        B[2 * nb + 1] = '*';
        for(i = 2 * nb; i > 0; i -= 2)
        {
            B[i] = B[i / 2];
            B[i - 1] = '*';
        }
        nb = 2 * nb + 1;
        for(i = 1; i <= na; ++i)
            nr[0][i] = 0;
        for(i = 1; i <= nb; ++i)
            nr[1][i] = 0;
        Manacher(nr[0], A, na);
        Manacher(nr[1], B, nb);
        RA = new Trie();


        RA = Build(nr[0], A, na, RA, 0);
        RA = Build(nr[1], B, nb, RA, 1);
        RA = Propaga(RA, 0);
        RA = Propaga(RA, 1);
        Solve(RA, false);
        RA = Remove(RA);
        delete RA;
        cout << "Case #" << t << ": " << sol << "\n";
    }
    return 0;
}
