#include <iostream>
#include <cstdio>
#include <unordered_set>
#include <tuple>
#include <cmath>

using namespace std;

typedef long long int Z;

Z M = 1000000007;

Z modpow(Z a, Z b) {
	if(b == 0) return 1;
	if(b & 1) return a * modpow(a, b - 1) % M;
	Z x = modpow(a, b / 2);
	return x * x % M;
}

Z inv_(Z x) {
	return modpow(x, M - 2);
}

Z inv[1000005];

int main() {
	for(Z i = 0; i < 1000005; ++i) inv[i] = inv_(i);
	
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
		
	for(int te = 0; te < Te; ++te) {
		Z n, m, k;
		cin >> n >> m >> k;
		
		Z ret = 0;
		Z binom = 1;
		for(Z t = 0; t < k; ++t) {
			if(t) {
				binom *= (k + 1 - t);
				binom %= M;
				binom *= inv[t];
				binom %= M;
			}
			
			Z term = binom;
			if(t & 1) {
				term = M - term;
				term %= M;
			}
			
			term *= (k - t);
			term %= M;
			
			term *= pow((k - t - 1), n - 1);
			term %= M;
			
		//	cout << t << ": " << term << ": " << binom << ", " << (k - t) % M << ", " << pow((k - t - 1) % M, n - 1) << "\n";
			
			ret += term;
			ret %= M;
		}
		
		for(Z i = 1; i <= k; ++i) {
			ret *= (m + 1 - i);
			ret %= M;
			ret *= inv[i];
			ret %= M;
		}
		
		cout << "Case #" << te + 1 << ": " << ret << "\n";
	}
	
	return 0;
}
