#include <iostream>
#include <cstdio>
#include <unordered_set>
#include <tuple>
#include <cmath>

using namespace std;

typedef long long int Z;

Z M = 1000000007;

Z modpow(Z a, Z b) {
	if(b == 0) return 1;
	if(b & 1) return a * modpow(a, b - 1) % M;
	Z x = modpow(a, b / 2);
	return x * x % M;
}

Z inv_(Z x) {
	return modpow(x, M - 2);
}

Z inv[1000005];

Z lols[1000005];

Z tek[1000005];

Z n, m, k;

Z gaa(Z x) {
	if(lols[x] != -1) return lols[x];
//	cout << x << "\n";
	Z a = tek[x];
	Z b = x / a;
	if(a == 1) {
		lols[x] = modpow(x, n - 1);
	} else {
		lols[x] = gaa(a) * gaa(b) % M;
	}
	return lols[x];
}

int main() {
	for(Z i = 0; i < 1000005; ++i) inv[i] = inv_(i);
	
	for(Z x = 1; x < 1000005; ++x) {
		for(Z i = x + x; i < 1000005; i += x) {
			tek[i] = x;
		}
	}
	
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
		
	for(int te = 0; te < Te; ++te) {
		cin >> n >> m >> k;
		
		fill(lols, lols + k + 1, -1);
		lols[0] = 0;
		if(n == 1) lols[0] = 1;
		lols[1] = 1;
		
		Z ret = 0;
		if(m >= k) {
		Z binom = 1;
		for(Z t = 0; t < k; ++t) {
			if(t) {
				binom *= (k + 1 - t);
				binom %= M;
				binom *= inv[t];
				binom %= M;
			}
			
			Z term = binom;
			if(t & 1) {
				term = M - term;
				term %= M;
			}
			
			term *= (k - t);
			term %= M;
			
			Z a = gaa(k - t - 1);
//			Z b = modpow(k - t - 1, n - 1);
//			if(a != b) cerr << "FAIL\n";
			term *= a;
			term %= M;
			
			ret += term;
			ret %= M;
		}
		
		for(Z i = 1; i <= k; ++i) {
			ret *= (m + 1 - i);
			ret %= M;
			ret *= inv[i];
			ret %= M;
		}
		}
		cout << "Case #" << te + 1 << ": " << ret << "\n";
	}
	
	return 0;
}
