#include <iostream>
#include <cstdio>
#include <unordered_set>
#include <tuple>
#include <cmath>
#include <sstream>
#include <vector>
#include <cassert>
#include <queue>

using namespace std;

int n, m;
vector<vector<int>> G;

int vert(int turn, int a, int b) {
	return turn + 2 * (a + n * b);
}

int outdeg[100];
int counter[20000];

int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
		
	for(int te = 0; te < Te; ++te) {
		cin >> n >> m;
		G.clear();
		G.resize(n);
		fill(outdeg, outdeg + n, 0);
		for(int i = 0; i < m; ++i) {
			int b, e;
			cin >> b >> e;
			--b;
			--e;
			G[e].push_back(b);
			++outdeg[b];
		}
		
		for(int i = 0; i < n; ++i) {
		for(int j = 0; j < n; ++j) {
			counter[vert(0, i, j)] = 1;
			counter[vert(1, i, j)] = outdeg[j];
		}
		}
		
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		
		queue<int> Q;
		for(int i = 0; i < n; ++i) {
		for(int t = 0; t < 2; ++t) {
			int v = vert(t, i, i);
			counter[v] = 0;
			Q.push(v);
		}
		}
		
		while(!Q.empty()) {
			int v = Q.front();
			Q.pop();
			int j = v;
			int turn = j & 1;
			j >>= 1;
			int i = j % n;
			j /= n;
			
			if(turn == 0) {
				for(int x : G[j]) {
					int v2 = vert(1, i, x);
					--counter[v2];
					if(counter[v2] == 0) Q.push(v2);
				}
			} else {
				for(int x : G[i]) {
					int v2 = vert(0, x, j);
					--counter[v2];
					if(counter[v2] == 0) Q.push(v2);
				}
			}
		}
		
		if(counter[vert(1, y, x)] > 0) {
			cout << "Case #" << te + 1 << ": Yes\n";
		} else {
			cout << "Case #" << te + 1 << ": No\n";
		}
	}
	
	return 0;
}
