#include <iostream>
#include <cstdio>
#include <unordered_set>
#include <tuple>
#include <cmath>

using namespace std;

typedef long long int Z;

namespace std {
template <>
struct hash<pair<Z, Z>> {
	size_t operator()(pair<Z, Z> p) const {
		return p.first + 7153451543LL * p.second;
	}
};
}

int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
		
	for(int te = 0; te < Te; ++te) {
		Z A;
		Z B;
		cin >> A >> B;
		
		unordered_set<Z> seen;
		unordered_set<pair<Z, Z>> seenp;
		seen.insert(A);
		seen.insert(B);
		seenp.emplace(A, B);
		
		for(;;) {
			tie(A, B) = make_tuple(B, abs(A - B));
			if(seenp.count(make_pair(A, B))) break;
			seenp.emplace(A, B);
			seen.insert(B);
		}
		
		cout << "Case #" << te + 1 << ": " << seen.size() << "\n";
	}
	
	return 0;
}
