#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
#define modul 1000000007

int modsum(int a, int b) {
	ll x = a + b;
	return x % modul;
}

int modsub(int a, int b) {
	ll x = a - b + modul;
	return x % modul;
}

int modmpl(ll a, ll b) {
	ll x = a * b;
	return x % modul;
}

int power(int x, int e) {
	if (e == 1) return x % modul;
	if (e == 0) return 1;
	if (e % 2 == 0) {
		ll y = power(x, e/2);
		return modmpl(y ,y);
	}
	else {
		ll y = power(x, e/2);
		return modmpl(modmpl(y, y), x);
	}
}

int deg[1000001];

int main () {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	scanf("%d", &t);
	for (int i = 1; i <= 1000000; ++i) {
		deg[i] = power(i, modul - 2);
	}
	for (int i = 0; i < t ; ++i) {
		int n, m, k;
		scanf("%d%d%d", &n, &m, &k);
		if (k == 1) {
			if (n == 1)
				printf("Case #%d: %d\n", i+1, m);
			else
				printf("Case #%d: %d\n", i+1, 0);
			continue;
		}
		int x = power(k - 1, n - 1);
		int y = power(k - 2, n - 1);
		x = modmpl(x, k);
		y = modmpl(modmpl(y, k), k - 1);
		int S = modsub(x, y);
		int init = 1;
		for (int j = 1; j <= k; ++j) {
			init = modmpl(init, m + 1 - j);
			int div = deg[j];
			init = modmpl(init, div);
		}
		int ans = modmpl(S, init);
		printf("Case #%d: %d\n", i+1, ans);
	}
	return 0;
}