#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <string>

using namespace std;

typedef long long ll;

const int maxn = 5e5;

string s;
int n;

ll slowsolve() {
	ll res = 0;
	for (int i = 0; i < n; i++) {
		string ca = "";
		string cb = "";
		for (int j = i; j < n; j++) {
			ca = ca + s[j];
			cb = s[j] + cb;
			res += ca == cb;
		}
	}
	return res;
}

void gen() {
	s = "";
	n = 10;
	for (int i = 0; i < n; i++) {
		s += rand() % 3 + 'a';
	}
}

struct node {
	int link, len;
	int cnt[2];
	char c;
	int go[28];
	int p[19];

	node() {
		link = -1;
		len = -1;
		memset(p, -1, sizeof(p));
		cnt[0] = cnt[1] = 0;
		c = 0;
		memset(go, -1, sizeof(go));
	}
};

int sz[2], cur[2], delta[2], type;
node t[2][maxn];
int it;
int maxpal[2][maxn];

char get(int i) {
	if (i < 0) return -i;
	if (i > it) return 5;
	if (i >= s.length()) return 6;
	// lovely constants
	return s[i];
}

int getlink(int k, int v) {
	if (t[k][v].link != -1) return t[k][v].link;
	if (t[k][v].len == 1) return 0;

	int cv = t[k][v].p[0];
	cv = getlink(k, cv);
	cv = t[k][cv].go[t[k][v].c];
	if (cv == -1) {
		cv = 0;
		if (t[k][cv].go[t[k][v].c] != -1) cv = t[k][cv].go[t[k][v].c];
	}
	return cv;
}

void go(int k, char c) {
	if (t[k][cur[k]].go[c] == -1) {
		t[k][cur[k]].go[c] = sz[k];
		t[k][sz[k]].p[0] = cur[k];
		for (int i = 1; i < 19; i++) t[k][sz[k]].p[i] = t[k][t[k][sz[k]].p[i - 1]].p[i - 1];
		t[k][sz[k]].len = t[k][cur[k]].len + 1;
		t[k][sz[k]].c = c;
		sz[k]++;
	}
	cur[k] = t[k][cur[k]].go[c];
}

void add(int k, char c) {
	int center = (it - 1) - t[k][cur[k]].len + 1 - delta[k];
	int len = t[k][cur[k]].len;

	if (get(center - len) == get(center + len + delta[k])) {
		go(k, c);
		return;
	}
	int L = center - len + 1;
	int R = center + len - 1 + delta[k];
	while (1) {
		if (center != -1) maxpal[k][center] = cur[k];
		t[k][cur[k]].cnt[type]++;

		center++;
		cur[k] = center + delta[k] <= R ? maxpal[k][L + R - center - delta[k]] : 0;
		len = t[k][cur[k]].len;
		if (center + len + delta[k] > it && cur[k] != 0) {
			for (int i = 18; i >= 0; i--) {
				int nv = t[k][cur[k]].p[i];
				int nlen = t[k][nv].len;
				if (center + nlen + delta[k] > it && nv != 0) {
					cur[k] = nv;
					len = nlen;
				}
			}
			int nv = t[k][cur[k]].p[0];
			int nlen = t[k][nv].len;
			cur[k] = nv;
			len = nlen;
		}
		if (get(center - len) == get(center + len + delta[k])) {
			go(k, c);
			break;
		}
		if (center == it) break;
	}
}

ll fastsolve() {
	for (int i = 0; i < min(maxn, 2 * n); i++) t[0][i] = t[1][i] = node();

	delta[0] = 0;
	sz[0] = 1;
	cur[0] = 0;
	t[0][0].link = 0;
	for (int i = 0; i < 19; i++) t[0][0].p[i] = 0;
	t[0][0].len = 0;

	delta[1] = 1;
	sz[1] = 1;
	cur[1] = 0;
	t[1][0].link = 0;
	for (int i = 0; i < 19; i++) t[1][0].p[i] = 0;
	t[1][0].len = 0;

	if (s == "daadd") {
		s = s;
	}

	type = 0;
	for (it = 0; it <= n; it++) {
		add(0, s[it] - 'a' + 2);
		add(1, s[it] - 'a' + 2);
		if (s[it] == 'a' - 1) type = 1;
	}

	for (int k = 0; k < 2; k++) {
		for (int v = sz[k] - 1; v > 0; v--) {
			for (int o = 0; o < 2; o++) {
				t[k][t[k][v].p[0]].cnt[o] += t[k][v].cnt[o];
			}
		}
	}

	ll ans = 0;
	for (int i = 1; i < sz[0]; i++) {
		ans += t[0][i].cnt[0] * 1LL * t[0][i].cnt[1];
		//ans += t[0][i].cnt[0];
	}
	for (int i = 1; i < sz[1]; i++) {
		ans += t[1][i].cnt[0] * 1LL * t[1][i].cnt[1];
		//ans += t[1][i].cnt[0];
	}

	return ans;
}

void stress(bool f) {
	if (!f) return;
	for (int it = 0;; it++) {
		gen();
		cerr << it << " " << s << endl;
		ll ans1 = fastsolve();
		ll ans2 = slowsolve();
		if (ans1 != ans2) {
			cout << ans1 << " instead of " << ans2 << endl;
			cout << s << endl;
			break;
		}
	}
	exit(0);
}

char bufa[maxn], bufb[maxn];

int main() {
	freopen("input.txt", "r", stdin);

	stress(0);

	int T;
	cin >> T;
	for (int test = 1; test <= T; test++) {
		string a, b;
		scanf("%s %s\n", bufa, bufb);
		a = bufa;
		b = bufb;
		s = "";
		s += a;
		s += (char)('a' - 1);
		s += b;
		s += (char)('a' - 2);

		n = s.length();
		cout << "Case #" << test << ": " << fastsolve() << endl;
	}

	return 0;
}