#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

#define MOD 1000000007

typedef long long ll;
typedef long double ld;

using namespace std;

int n, m, k;

//n^d
ll powb(int n, int d) {
	if (d == 0)
		return 1;
	ll p = powb(n, d/2);
	p = (p*p) % MOD;
	if (d % 2)
		return (p*n) % MOD;
	return p;
}

ll c(int k, int n) {
	int b1 = k;
	int b2 = n-k;
	if (b1 > b2) {
		int temp = b1;
		b1 = b2;
		b2 = temp;
	}
	//b1 <= b2
	ll top = 1;
	for (int i = b2+1; i <= n; ++i)
		top = (top * i) % MOD;
	ll bottom = 1;
	for (int i = 2; i <= b1; ++i)
		bottom = (bottom * i) % MOD;
	return (top * powb(bottom, MOD-2)) % MOD;
}


int answer() {
	//printf("c(%d, %d) = %d\n", k, m, c(k, m));
	//printf("pow(%d, %d) = %d\n", k-1, n-1, pow(k-1, n-1));
	ll answer = (((c(k, m) * k) % MOD) * powb(k-1, n-1)) % MOD;
	return answer;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	for (int test = 1; test <= t; ++test) {
		cin >> n >> m >> k;
		cout << "Case #" << test << ": " << answer() << endl;
	}

	return 0;
}