#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

const int mod = 1000 * 1000 * 1000 + 7;

int binPow(int a, int k)
{
    if (k == 0)
        return 1 % mod;
    if (k % 2 == 0)
    {
        LL t = binPow(a, k / 2);
        return (t * t) % mod;
    }
    else
    {
        LL t = binPow(a, k - 1);
        return (t * a) % mod;
    }
}


void solve()
{
    int t;
    scanf("%d", &t);
    for (int q = 0; q < t; q++)
    {
        int n, m, k;
        scanf("%d %d %d", &n, &m, &k);
        int ans = 0;
        if (m < k)
            ans= 0;
        else
        {
            int C = 1;
            int z = 1;
            for (int i = 1; i <= k; i++)
            {
                int tmp = binPow(k - i, n - 1);
                tmp = (LL(tmp) * (k - i + 1)) % mod;
                ans = ((ans + z * tmp) % mod + mod) % mod;

                int K = k - i + 1;
                int d = binPow(i, mod - 2);
                K = (LL(K) * d) % mod;
                C = (LL(C) * K) % mod;
                tmp = (LL(tmp) * C) % mod;
                z *= -1;
            }

            int c = 1;
            for (int i = 0; i < k; i++)
            {
                int K = m - i;
                int d = binPow(i + 1, mod - 2);
                K = (LL(K) * d) % mod;
                c = (LL(c) * K) % mod;
            }
            ans = (LL(ans) * c) % mod;
        }
        printf("Case #%d: %d\n", q + 1, ans);
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif