#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"
#define MOD 1000000007
#define MAXN 1000100

int n, m, k, res, s;
int C[MAXN], inv[MAXN];

int pow(int x, int y){
    if (y == 0) return 1;
    if (y == 1) return x % MOD;
    x = x % MOD;
    LL k = pow(x, y / 2);
    k = (k * k) % MOD;
    if (y % 2) k = (k * x) % MOD;
    return k;
}

int fac(int x){
    LL fac = 1;
    for (int i = 2; i <= x; i++)
        fac = (fac * i) % MOD;
    return fac;
}

void readin(){
    scanf("%d%d%d", &n, &m, &k);
}

void init(){
    C[0] = 1;
    C[1] = k;
    for (int i = 2; i <= k; i++){
        C[i] = ((LL(C[i - 1]) * (k - i + 1)) % MOD * inv[i]) % MOD;
    }
    s = 1;

    s = fac(k);
    s = pow(s, MOD - 2);
    //s = inv[s];

    for (int i = m; i > m - k; i--){
        s = (LL(s) * i) % MOD;
    }

    res = 0;
}

void process(){
    int z = 1;
    for (int i = 0; i < k; i++){
        res = (res + ((LL(z) * C[i] * (k - i)) % MOD * pow(k - i - 1, n - 1)) % MOD) % MOD;
        if (res < 0) res += MOD;
        z = -z;
    }
    res = (LL(res) * s) % MOD;
    printf("%d\n", res);
}

void solve()
{
    for (int i = 1; i <= 1000000; i++)
        inv[i] = pow(i, MOD - 2);
    
    int test;
    scanf("%d", &test);
    for (int i = 1; i <= test; i++){
        readin();
        init();
        process();
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif