#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << "\n"; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << "\n" << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << "\n";
 
#define NAME "problem"

typedef pair<LL, LL> pll;

pll conv(string s)
{
    assert(s.find('/') != -1);
    forn(i, s.size())
        if (s[i] == '.' || s[i] == '/')
            s[i] = ' ';

    vi a(4); int len;
    istringstream is(s);
    is >> a >> len;

    LL mask = 0;
    forn(i, 4)
    {
        mask <<= 8;
        mask |= a[i];
    }

    LL l = mask;
    LL r = mask | ((1LL << (32 - len)) - 1);

    return pll(l, r);
}

const LL maxn = LL(1) << 32;

int n;
vector<pll> a;
vector<pll> b;
vector<LL> pp;

void rec(LL tl, LL tr, LL l, LL r)
{
    if (l > r)
        return;
    if (l == tl && r == tr)
        b.push_back(pll(l, r));
    else
    {
        LL tm = (tl + tr) / 2;
        rec(tl, tm, l, min(r, tm));
        rec(tm + 1, tr, max(l, tm + 1), r);
    }
}

vector<pll> prepare(vector<pll> a)
{
    sort(all(a));
    return a;
}

string i2s(LL x)
{
    ostringstream os; os << x; return os.str();
}

string to_str(pll segm)
{
    LL mask = segm.X;

    int len = lower_bound(all(pp), segm.Y - segm.X + 1) - pp.begin();
    len = 32 - len;

    string res;

    LL part = (LL(1) << 8) - 1;
    res += i2s((mask >> 24) & part) + ".";
    res += i2s((mask >> 16) & part) + ".";
    res += i2s((mask >> 8)  & part) + ".";
    res += i2s(mask & part);
    res += "/" + i2s(len);

    return res;
}

void solve(int test)
{
    a.clear();
    b.clear();

    cout << "Case #" << test << ":" << "\n";
    cin >> n;
    forn(i, n)
    {
        string s; cin >> s;
        a[i] = conv(s);
    }

    a = prepare(a);

    if (n == 0)
        b.push_back(pll(0, maxn - 1));
    else
    {
        rec( 0, maxn - 1, 0, a.front().X - 1);
        rec( 0, maxn - 1, a.back().Y + 1, maxn - 1);

        int last = 0;
        for (int i = 1; i < n; ++i)
        {
            if (last != -1 && a[i].X < a[last].Y)
                continue;
            rec(0, maxn - 1, a[last].Y + 1, a[i].X - 1);
            last = i;
        }
    }

    cout << b.size() << "\n";
    forn(i, b.size())
        cout << to_str(b[i]) << "\n";
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    ios_base::sync_with_stdio(false);

    forn(i, 50)
        pp.push_back(LL(1) << i);

    int t; cin >> t;
    forn(i, t)
        solve(i + 1);
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif