#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

char buf[100];

typedef unsigned int uint;
typedef pair<uint, uint> pii;

pii conv(char *s)
{
    for (int i = 0; s[i]; ++i)
        if (s[i] == '.' || s[i] == '/')
            s[i] = ' ';

    int a, b, c, d, len;

    sscanf(s, "%d %d %d %d %d", &a, &b, &c, &d, &len);

    uint mask = (uint(a) << 24) | (uint(b) << 16) | (uint(c) << 8) | uint(d);
    uint sub_zero = (~ uint(0)) << (32 - len);
    uint sub_one = ~sub_zero;

    uint l = mask & sub_zero;
    uint r = mask | sub_one;
    return pii(l, r);
}

vector<uint> pp;
uint maxpp(uint xx)
{
    int p = upper_bound(all(pp), xx) - pp.begin();
    --p;
    return pp[p];
}

vector<pii> b;

void rec(uint l, uint r, uint tl, uint tr)
{
    if (l > r)
        return;
    if (l == tl && r == tr)
        b.push_back(pii(l, r));
    else
    {
        uint tm = (LL(tl) + LL(tr)) / 2;
        rec(l, min(r, tm), tl, tm);
        rec(max(l, tm + 1), r, tm + 1, tr);
    }
}

void print(const pii &p)
{
    uint mask = p.X;
    uint sub = (uint(1) << 8) - 1;
    int len =  p.X == 0 && p.Y == (~uint(0)) ? 32 : int(lower_bound(all(pp), p.Y - p.X + 1) - pp.begin());
    len = 32 - len;
    printf("%d.%d.%d.%d/%d\n", int(mask >> 24), int((mask >> 16) & sub), int((mask >> 8) & sub), int(mask & sub), len);
}

void solve(int test)
{
    b.clear();

    printf("Case #%d:\n", test);
    int n; scanf("%d", &n);
    vector<pii> a(n);
    forn(i, n)
    {
        scanf("%s", buf);
        a[i] = conv(buf);
    }
    sort(all(a));

    if (n == 0)
        b.push_back(pii(0, ~uint(0)));
    else
    {
        if (a.front().X)
            rec(0, a.front().X - 1, 0, ~uint(0));
        if (a.back().Y != (~uint(0)))
            rec(a.back().Y + 1, ~uint(0), 0, ~uint(0));

        int last = 0;
        for (int i = 1; i < n; ++i)
        {
            if (last != -1 && a[i].X < a[last].Y)
                continue;
            rec(a[last].Y + 1, a[i].X - 1, 0, ~uint(0));
            last = i;
        }
    }

    printf("%d\n", b.size());
    forn(i, b.size())
        print(b[i]);
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    forn(i, 32)
        pp.push_back(uint(1) << i);

    int t; scanf("%d", &t);
    forn(i, t)
        solve(i + 1);
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif