#include <iostream>
#include <vector>

using namespace std;

const int kModulo = 1000 * 1000 * 1000 + 7;

int pow(int a, int b) {
    if (b == 0)
        return 1;
    if (b % 2)
        return 1LL * a * pow(a, b - 1) % kModulo;

    int v = pow(a, b / 2);
    return 1LL * v * v % kModulo;
}

int main() {
    ios::sync_with_stdio(false);

    int T; cin >> T;
    for (int test = 1; test <= T; ++test) {
        int N, M, K; cin >> N >> M >> K;

        vector<int> fact(K + 1, 1);
        for (int i = 1; i <= K; ++i)
            fact[i] = (1LL * fact[i - 1] * i) % kModulo;

        vector<int> ifact(K + 1, 1);
        ifact[K] = pow(fact[K], kModulo - 2);

        for (int i = K - 1; i > 0; --i)
            ifact[i] = (1LL * ifact[i + 1] * (i + 1)) % kModulo;

        vector<int> invMod(K + 1, 1);
        for (int i = 1; i <= K; ++i)
            invMod[i] = (1LL * ifact[i] * fact[i - 1]) % kModulo;

        vector<int> formula(K + 1, 0);
        for (int i = 0; i <= K; ++i)
            formula[i] = 1LL * i * pow(i - 1, N - 1) % kModulo;

        int aux = 0;
        for (int i = K; i >= 2; --i) {
            int multiplier = fact[K];
            multiplier = 1LL * multiplier * ifact[i] % kModulo;
            multiplier = 1LL * multiplier * ifact[K - i] % kModulo;
            if (i % 2 != K % 2)
                multiplier = -multiplier;

            aux = (aux + 1LL * formula[i] * multiplier) % kModulo;
        }

        if (aux < 0)
            aux += kModulo;

        aux = 1LL * aux * ifact[K] % kModulo;
        int answer = aux;
        for (int i = M - K + 1; i <= M; ++i)
            answer = 1LL * answer * i % kModulo;
        cout << "Case #" << test << ": " << answer << "\n";
    }
}
