#include <iostream>
#include <vector>
#include <map>

using namespace std;

struct Tree {
    Tree(int _length):
            length(_length),
            link(nullptr) {
        count[0] = count[1] = 0;
    }

    int64_t total() {
        int64_t answer = 0;
        for (auto &p : edge) {
            answer += p.second->total();
        }
        answer += 1LL * count[0] * count[1];
        return answer;
    }

    int length;
    Tree *link;
    map<char, Tree*> edge;
    int count[2];
};

void count(string A, Tree *zero, int where, vector<Tree *>& nodes) {
    Tree *now = zero;
    for (int i = 0; i < int(A.size()); ++i) {
        while (now) {
            if (now->length == i) {
                now = now->link;
                continue;
            }
            if (A[i - now->length - 1] == A[i])
                break;
            now = now->link;
        }

        if (now->edge[A[i]]) {
            now = now->edge[A[i]];
            now->count[where]++;
            continue;
        }

        Tree *next = new Tree(now->length + 2);
        nodes.push_back(next);

        now->edge[A[i]] = next;
        for (Tree *link = now->link; link; link = link->link) {
            if (link->length < i && A[i - link->length - 1] == A[i]) {
                next->link = link->edge[A[i]];
                break;
            }
        }

        if (!next->link)
            next->link = zero;
        next->count[where]++;
        now = next;
    }
 }

int64_t solve(string A, string B) {
    Tree *minus1 = new Tree(-1);
    Tree *zero = new Tree(0);
    zero->link = minus1;

    vector<Tree*> nodes;
    count(A, zero, 0, nodes);
    count(B, zero, 1, nodes);

    for (auto it = nodes.rbegin(); it != nodes.rend(); ++it) {
        auto node = *it;
        for (int where = 0; where < 2; ++where)
            node->link->count[where] += node->count[where];
    }

    int64_t answer = minus1->total() + zero->total();
    answer -= 1LL * zero->count[0] * zero->count[1];
    answer -= 1LL * minus1->count[0] * minus1->count[1];
    return answer;
}

int main() {
    int T; cin >> T;
    for (int test = 1; test <= T; ++test) {
        string A, B; cin >> A >> B;

        cout << "Case #" << test << ": " << solve(A, B) << "\n";
    }
}
