#include <iostream>
#include <vector>
#include <queue>
#include <array>

using namespace std;

struct state {
    int x, y, move;
};

int main() {
    ios::sync_with_stdio(false);

    int T; cin >> T;

    for (int test = 1; test <= T; ++test) {
        int N, M; cin >> N >> M;

        vector< vector<int> > E(N, vector<int>(N, 0));
        for (int i = 0; i < M; ++i) {
            int x, y; cin >> x >> y;
            E[x - 1][y - 1] = 1;
        }

        vector<int> degree(N, 0);
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                if (E[i][j])
                    ++degree[i];

        queue< state> Q;
        vector< vector< array<bool, 2> > > used(N, vector< array<bool, 2> >(N, {{false, false}}));
        for (int i = 0; i < N; ++i) {
            Q.push(state{i, i, 0});
            Q.push(state{i, i, 1});
            used[i][i][0] = true;
            used[i][i][1] = 0;
        }

        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                if (degree[i] == 0 && i != j) {
                    Q.push(state{i, j, 0});
                    used[i][j][0] = true;
                }

        vector< vector<int> > movesLeft(N, vector<int>(N, 0));
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                movesLeft[i][j] = degree[i];

        while (!Q.empty()) {
            int x = Q.front().x;
            int y = Q.front().y;
            int move = Q.front().move;
            Q.pop();

            if (move == 0) { // Bob is moving
                // Alice can come from any state
                for (int i = 0; i < N; ++i)
                    if (E[i][y] && !used[x][i][1]) {
                        used[x][i][1] = true;
                        Q.push(state{x, i, 1});
                    }
            } else {
                // we remove Bob's moves
                for (int i = 0; i < N; ++i)
                    if (E[i][x] && !used[i][y][0])
                        if (--movesLeft[i][y] == 0) {
                            used[i][y][0] = true;
                            Q.push(state{i, y, 0});
                        }
            }
        }

        int x, y; cin >> x >> y;
        --x; --y;

        cout << "Case #" << test << ": ";
        if (used[x][y][0])
            cout << "No\n";
        else
            cout << "Yes\n";
    }
}
